#ifndef _ConfigCamera
#define _ConfigCamera

#include <cstdlib>

// classe de stockage des parametres d'une cam a un instant donne;
// redondant avec les variables de la classe Camera, a ameliorer.

class ConfigCamera {
	
public :
	
	ConfigCamera (double posX=0.0,double posY=0.0,double posZ=0.0,double anglePlan=0.0,double angleVert=0.0,double roll=0.0,double zoom=1.0) {
		this->posX=posX;
		this->posY=posY;
		this->posZ=posZ;
		this->anglePlan=anglePlan; // par rapport  l'axe Oz (comme en physique)
		this->angleVert=angleVert; // par rapport au plan xOy
		this->roll=roll;
		this->zoom=zoom;
	}
	
	ConfigCamera (const ConfigCamera& confCam) {
		posX=confCam.posX;
		posY=confCam.posY;
		posZ=confCam.posZ;
		anglePlan=confCam.anglePlan;
		angleVert=confCam.angleVert;
		roll=confCam.roll;
		zoom=confCam.zoom;
	}
	
	~ConfigCamera () {}
	
	double posX,posY,posZ; // position spatiale du centre de gravite
	double anglePlan,angleVert; // orientation dans l'espace
	double roll;
	double zoom; // force du zoom (1.0 pour normal)

};

#endif
