#include "Configuration.h"

// methode transformant une configuration en triplet de points 3D pour paule, coude et main
// ordre suppose des parametres : toujours yaw (theta), puis pitch (phi), puis roll (dzeta)
double* Configuration::conf2coord3D() const {
	
	double* res=(double*)malloc(9*sizeof(double));
	res[0]=RAY_STATION;
	res[1]=(*this)[0];
	res[2]=0.0;
	double tmpCosP=cos((*this)[2]),tmpSinP=sin((*this)[2]),
			tmpCosV=cos((*this)[1]),tmpSinV=sin((*this)[1]);
	res[3]=res[0]+LONG_EC*tmpCosP*tmpSinV;
	res[4]=res[1]+LONG_EC*tmpSinP*tmpSinV;
	res[5]=LONG_EC*tmpCosV;
	tmpSinV=sin((*this)[4]);
	res[6]=res[3]+LONG_CP*tmpCosP*tmpSinV;
	res[7]=res[4]+LONG_CP*tmpSinP*tmpSinV;
	res[8]=res[5]+LONG_CP*cos((*this)[4]);

	// ajout d'une rotation d'angle (*this)[3] d'axe epaule-coude :
	// on utilise la formule M[app,e']=P(e,e')M[app,e](inv(P(e,e')) :
	double *coeffsX=(double*)malloc(3*sizeof(double)),
			*coeffsY=(double*)malloc(3*sizeof(double)),
			*coeffsZ=(double*)malloc(3*sizeof(double));
	getPassMatrix(coeffsX,coeffsY,coeffsZ,(*this)[2],(*this)[1]);

	double vectPo[]={res[6]-res[0],res[7]-res[1],res[8]-res[2]}; // point X
	double* apresRotate=rotatePoint(coeffsX,coeffsY,coeffsZ,(*this)[3],vectPo);
	for (int i=2; i>=0; i--) res[i+6]=res[i]+apresRotate[i];
	free(apresRotate);
	
	free(coeffsX);
	free(coeffsY);
	free(coeffsZ);

	return res;
	
	/* code Khaled :
	robots1->set_config(qtmp); 
	robots1->compute_forward_kinematics();
	robots1->update_iv_transf();
	Taccu->apply ...
	
	avec les includes et imports qui vont bien. --> possible (demain soir)
	*/
}
