// classe decrivant une configuration du bras-robot

#ifndef _Configuration
#define _Configuration

#include <cstdlib>
#include <cmath>
#include <vector>
#include "Functions.h"
#include "Constantes.h"

using namespace std;

class Configuration : public vector<double> {

public:
	
	Configuration() : vector<double>(DIM) {}
	
	Configuration(double* vect_degres) {
		for (int i=0; i<DIM; i++) push_back(vect_degres[i]);
	}
	
	Configuration (const Configuration& conf) {
		for (int i=0; i<DIM; i++) push_back(conf[i]);
	}
	
	~Configuration () {}
	
	// methode transformant une configuration en triplet de points 3D pour paule, coude et poignet
	double* conf2coord3D() const;
	
};

#endif
