#include "FilmageFixe.h"

#include <iostream>
using namespace std;

// initialisation des cameras (a corriger avec les vraies valeurs) :
FilmageFixe::FilmageFixe () {
	camerasF=new Camera[14];
	
	camerasF[0].posX=RAY_STATION;
	camerasF[0].posY=0;
	camerasF[0].posZ=0;
	camerasF[0].roll=0.0;

	camerasF[1].posX=RAY_STATION;
	camerasF[1].posY=50;
	camerasF[1].posZ=0;
	camerasF[1].roll=0.0;
	
	camerasF[2].posX=RAY_STATION;
	camerasF[2].posY=100;
	camerasF[2].posZ=0;
	camerasF[0].roll=0.0;
	
	camerasF[3].posX=RAY_STATION;
	camerasF[3].posY=150;
	camerasF[3].posZ=0;
	camerasF[0].roll=0.0;
	
	camerasF[4].posX=RAY_STATION;
	camerasF[4].posY=200;
	camerasF[4].posZ=0;
	camerasF[0].roll=0.0;
	
	camerasF[5].posX=RAY_STATION;
	camerasF[5].posY=250;
	camerasF[5].posZ=0;
	camerasF[0].roll=0.0;
	
	camerasF[5].posX=RAY_STATION;
	camerasF[5].posY=300;
	camerasF[5].posZ=0;
	camerasF[0].roll=0.0;
	
	camerasF[6].posX=RAY_STATION;
	camerasF[6].posY=350;
	camerasF[6].posZ=0;
	camerasF[0].roll=0.0;
	
	camerasF[7].posX=RAY_STATION;
	camerasF[7].posY=400;
	camerasF[7].posZ=0;
	camerasF[0].roll=0.0;
	
	camerasF[8].posX=RAY_STATION;
	camerasF[8].posY=450;
	camerasF[8].posZ=0;
	camerasF[0].roll=0.0;
	
	camerasF[9].posX=RAY_STATION;
	camerasF[9].posY=500;
	camerasF[9].posZ=0;
	camerasF[0].roll=0.0;
	
	camerasF[10].posX=RAY_STATION;
	camerasF[10].posY=550;
	camerasF[10].posZ=0;
	camerasF[0].roll=0.0;
	
	camerasF[11].posX=RAY_STATION;
	camerasF[11].posY=600;
	camerasF[11].posZ=0;
	camerasF[0].roll=0.0;
	
	camerasF[12].posX=RAY_STATION;
	camerasF[12].posY=650;
	camerasF[12].posZ=0;
	camerasF[0].roll=0.0;
	
	camerasF[13].posX=RAY_STATION;
	camerasF[13].posY=700;
	camerasF[13].posZ=0;
	camerasF[0].roll=0.0;
}

// obtention des configurations de cameras pour l'image courante :
ConfigCamera* FilmageFixe::getCamConfig() {
	static int indice1=-1,indice0=-1,indice2=-1; // les precedents indices des cameras, que l'on teste en premier
	ConfigCamera* resConfigs=new ConfigCamera[3];
	
	// on ordonne les cameras pour le filmage de cette configuration :
	double bestVis1=0.0,bestVis0=0.0,bestVis2=0.0;
	double* visibilite=(double*)calloc(NB_CAMS,sizeof(double));
	int bestInd1=-1,bestInd0=-1,bestInd2=-1;
	for (int j=NB_CAMS-1; j>=0; j--) {
		visibilite[j]=camerasF[j].getVisibilite(); // initialise aussi les angles
		if (visibilite[j]>bestVis1) {
			bestVis2=bestVis0;
			bestVis0=bestVis1;
			bestVis1=visibilite[j];
			
			bestInd2=bestInd0;
			bestInd0=bestInd1;
			bestInd1=j;
		}
		
		else if (visibilite[j]>bestVis0) {
			bestVis2=bestVis0;
			bestVis0=visibilite[j];
			
			bestInd2=bestInd0;
			bestInd0=j;
		}
		
		else if (visibilite[j]>bestVis2) {
			bestVis2=visibilite[j];
			bestInd1=j;
		}
	}
	
	// nouveaute : reglage du zoom en fonction des distances a l'objectif
	double dist2Objectif;
	
	// ********** camera 1 (centrale) : ***************
	if (indice1>=0 && visibilite[indice1]>=SEUIL_VIS && indice1) {
		// on garde l'ancienne vue :
		// distance a l'objectif :
		dist2Objectif=sqrt((currPR[0]-camerasF[indice1].posX)*(currPR[0]-camerasF[indice1].posX)
							+ (currPR[1]-camerasF[indice1].posY)*(currPR[1]-camerasF[indice1].posY)
							+ (currPR[2]-camerasF[indice1].posZ)*(currPR[2]-camerasF[indice1].posZ));
		camerasF[indice1].zoom=maxF(dist2Objectif/distCamPR,1.0);
		resConfigs[1]=camerasF[indice1].getConfig();
	}
	else {
		if (bestInd1>=0) {
			// distance a l'objectif :
			dist2Objectif=sqrt((currPR[0]-camerasF[bestInd1].posX)*(currPR[0]-camerasF[bestInd1].posX)
								+ (currPR[1]-camerasF[bestInd1].posY)*(currPR[1]-camerasF[bestInd1].posY)
								+ (currPR[2]-camerasF[bestInd1].posZ)*(currPR[2]-camerasF[bestInd1].posZ));
			camerasF[bestInd1].zoom=maxF(dist2Objectif/distCamPR,1.0);
			resConfigs[1]=camerasF[bestInd1].getConfig();
			indice1=bestInd1;
		}
		else {
			// choix de la camera 7 (par defaut) :
			dist2Objectif=sqrt((currPR[0]-camerasF[7].posX)*(currPR[0]-camerasF[7].posX)
								+ (currPR[1]-camerasF[7].posY)*(currPR[1]-camerasF[7].posY)
								+ (currPR[2]-camerasF[7].posZ)*(currPR[2]-camerasF[7].posZ));
			camerasF[7].zoom=maxF(dist2Objectif/distCamPR,1.0);
			resConfigs[1]=camerasF[7].getConfig();
		}
	}

	// ********** camera 0 (gauche) : ***************
	if (indice0>=0 && visibilite[indice0]>=SEUIL_VIS) {
		// on garde l'ancienne vue :
		// distance a l'objectif :
		dist2Objectif=sqrt((currPR[0]-camerasF[indice0].posX)*(currPR[0]-camerasF[indice0].posX)
							+ (currPR[1]-camerasF[indice0].posY)*(currPR[1]-camerasF[indice0].posY)
							+ (currPR[2]-camerasF[indice0].posZ)*(currPR[2]-camerasF[indice0].posZ));
		camerasF[indice0].zoom=maxF(dist2Objectif/distCamPR,1.0);
		resConfigs[0]=camerasF[indice0].getConfig();
	}
	else {
		if (bestInd0>=0 && bestInd0!=indice1) {
			// distance a l'objectif :
			dist2Objectif=sqrt((currPR[0]-camerasF[bestInd0].posX)*(currPR[0]-camerasF[bestInd0].posX)
								+ (currPR[1]-camerasF[bestInd0].posY)*(currPR[1]-camerasF[bestInd0].posY)
								+ (currPR[2]-camerasF[bestInd0].posZ)*(currPR[2]-camerasF[bestInd0].posZ));
			camerasF[bestInd0].zoom=maxF(dist2Objectif/distCamPR,1.0);
			resConfigs[0]=camerasF[bestInd0].getConfig();
			indice0=bestInd0;
		}
		else {
			// choix de la camera 2 (par defaut) :
			dist2Objectif=sqrt((currPR[0]-camerasF[2].posX)*(currPR[0]-camerasF[2].posX)
								+ (currPR[1]-camerasF[2].posY)*(currPR[1]-camerasF[2].posY)
								+ (currPR[2]-camerasF[2].posZ)*(currPR[2]-camerasF[2].posZ));
			camerasF[0].zoom=maxF(dist2Objectif/distCamPR,1.0);
			resConfigs[0]=camerasF[2].getConfig();
		}
	}
	
	// ********** camera 2 (droite) : ***************
	if (indice2>=0 && visibilite[indice2]>=SEUIL_VIS) {
		// on garde l'ancienne vue :
		// distance a l'objectif :
		dist2Objectif=sqrt((currPR[0]-camerasF[indice2].posX)*(currPR[0]-camerasF[indice2].posX)
							+ (currPR[1]-camerasF[indice2].posY)*(currPR[1]-camerasF[indice2].posY)
							+ (currPR[2]-camerasF[indice2].posZ)*(currPR[2]-camerasF[indice2].posZ));
		camerasF[indice2].zoom=maxF(dist2Objectif/distCamPR,1.0);
		resConfigs[2]=camerasF[indice2].getConfig();
	}
	else {
		if (bestInd2>=0 && bestInd2!=indice1 && bestInd2!=indice0) {
			// distance a l'objectif :
			dist2Objectif=sqrt((currPR[0]-camerasF[bestInd2].posX)*(currPR[0]-camerasF[bestInd2].posX)
								+ (currPR[1]-camerasF[bestInd2].posY)*(currPR[1]-camerasF[bestInd2].posY)
								+ (currPR[2]-camerasF[bestInd2].posZ)*(currPR[2]-camerasF[bestInd2].posZ));
			camerasF[bestInd2].zoom=maxF(dist2Objectif/distCamPR,1.0);
			resConfigs[2]=camerasF[bestInd2].getConfig();
		}
		else {
			// choix de la camera 12 (par defaut) :
			dist2Objectif=sqrt((currPR[0]-camerasF[12].posX)*(currPR[0]-camerasF[12].posX)
								+ (currPR[1]-camerasF[12].posY)*(currPR[1]-camerasF[12].posY)
								+ (currPR[2]-camerasF[12].posZ)*(currPR[2]-camerasF[12].posZ));
			camerasF[12].zoom=maxF(dist2Objectif/distCamPR,1.0);
			resConfigs[2]=camerasF[12].getConfig();
		}
	}
	
	return resConfigs;
}
