#ifndef _Functions
#define _Functions

#include <cstdlib>
#include <string>
#include <cmath>
#include <time.h>
#include "Constantes.h"
#include "Global.h"

class Functions {

public :

	Functions () {
		srand(time(NULL));
	}
	
	~Functions () {}
	
	static double toFloat(std::string str) {
		char* chStr=(char*)malloc((str.size()+1)*sizeof(char));
		for (int i=str.size()-1; i>=0; i--) chStr[i]=str[i];
		chStr[str.size()]=0;
		double res=atof(chStr);
		free(chStr);
		return res;
	}
	
	// generateur aleatoire uniforme dans [0,1]:
	static double genAlea() {
		return (double)rand()/RAND_MAX;
	}
	
	// generateur aleatoire uniforme d'un entier dans [0,n-1] :
	static int genAleaInt(int n) {
		return rand()%n;
	}
	
	// bit aleatoire :
	static int randBit() {
		return 1-2*(rand()%2);
	}
	
	// min de deux entiers
	static int mini(int a,int b) {
		if (a<b) return a;
		return b;
	}
	
	// .. et max :
	static int maxi(int a,int b) {
		if (a>b) return a;
		return b;
	}

	// max de deux flottants :
	static double maxF(double a,double b) {
		if (a>b) return a;
		return b;
	}
	
	// fonction detectant si collision:
	static int collision(double* point);
	
	// test de colinearite :
	static bool colineaires(double* point1,double* point2,double* point3);
	
	// fonction calculant le point de repere courant :
	static void getRepPoint(int indice);
	
	// renvoit la matrice de passage en fonction des angles phi et theta :
	static void getPassMatrix(double* coeffsX,double* coeffsY,double* coeffsZ,double anglePlan,double angleVert);
	
	// fonction calculant les angles en coordonnees spheriques a partir d'un vecteur :
	static void getSphericAngles(double* vecteur,double& phi,double& theta);
	
	// fonction effectuant une rotation du point coeffs_, d'angle angle autour d'un axe vector :
	static double* rotatePoint(double* coeffsX,double* coeffsY,double* coeffsZ,double angle,double* vecteur);
	
	// calcul de la distance de vue :
	static void getViewDistance(int indice);

};
	
#define toFloat Functions::toFloat
#define genAlea Functions::genAlea
#define genAleaInt Functions::genAleaInt
#define randBit Functions::randBit
#define collision Functions::collision
#define mini Functions::mini
#define maxi Functions::maxi
#define maxF Functions::maxF
#define colineaires Functions::colineaires
#define getRepPoint Functions::getRepPoint
#define getPassMatrix Functions::getPassMatrix
#define getSphericAngles Functions::getSphericAngles
#define rotatePoint Functions::rotatePoint
#define getViewDistance Functions::getViewDistance

#endif
