#ifndef _Global
#define _Global

#include <cstdlib>
#include <vector>
#include "Zone.h"
#include "Idiom.h"

using namespace std;

class Global {

public :
	
	Global () {}
	
	~Global () {}
	
	// classe contenant le vecteur global de decoupage + nb de points parcourus (!)
	static vector<int> decoupageM,decoupageO,decoupageZ;
	static int indiceG;
	
	static vector<double> distObstacles; // distances calculees aux obstacles le long de la trajectoire
	static vector<Zone> zonesBase; // vecteur des zones de la station obtenues apres decoupage
	static vector<Idiom> idiomsBase; // vecteur des idiomes utilisables
	
	// coordonnes 3D correspondant a la position des 3 joints principaux du bras :
	static double* coord3D;
	
	// un peu pr debug.. : les coordonnees de chaque point d'obstacle lors du decoupageO
	// (0,0,0) indique qu'il n'y a pas d'obstacles dans l'horizon teste
	// + les coordonnees du point le plus proche appartenant au bras
	static vector<double*> coordObstacles;
	static vector<double*> coordPointsB;
	
	// distance courante d'une camera au point de repere
	static double distCamPR;
	
	// position courante du point de repere :
	// note : centre de gravite OU main OU milieu d'un segment [obstacle,point du bras]
	static double* currPR;
	
	// vecteur des points ou on filme que la main :
	static vector<bool> handPoints;
	
	// vecteur des points ou on zoom sur une partie du bras car obstacle
	static vector<bool> zoomObstPoints;

};

#endif

#define decoupageM Global::decoupageM
#define decoupageO Global::decoupageO
#define decoupageZ Global::decoupageZ
#define indiceG Global::indiceG
#define distObstacles Global::distObstacles
#define zonesBase Global::zonesBase
#define idiomsBase Global::idiomsBase
#define distCamPR Global::distCamPR
#define currPR Global::currPR
#define coord3D Global::coord3D
#define coordObstacles Global::coordObstacles
#define coordPointsB Global::coordPointsB
#define handPoints Global::handPoints
#define zoomObstPoints Global::zoomObstPoints
