#include "Lissage.h"

vector<ConfigCamera> Lissage::lisse(const vector<ConfigCamera>& configsCam,const vector<Configuration>& configurations) {
	vector<ConfigCamera> configsLisse(configsCam.size());
	int countUp=0,countDown=0; // compteurs nbFois Up et Down
	int countVal=0;
	double lastVal; // derniere valeur lue

	// Pour X :
	
	if (configsCam[0].posX<=configsCam[1].posX) countUp++;
	else countDown++;
	// on suppose qu'il n'y a pas de saut a ce stade (!)
	lastVal=configsCam[1].posX;
	for (int i=2; i<(int)configsCam.size(); i++) {
		if (configsCam[i].posX>=lastVal) {
			if (fabs(configsCam[i].posX-lastVal)>=SEUIL_LISS) {
				// saut : 
				if (countUp>0) {
					// on moyenne sur les montees :
					for (int j=countUp-1; j>=0; j--)
						configsLisse[countVal++].posX=(configsCam[i-1-j].posX+configsCam[i-2-j].posX)/2.0;
					countUp=0;
				}
				else if (countDown>0) {
					// on moyenne sur les descentes :
					for (int j=countDown-1; j>=0; j--)
						configsLisse[countVal++].posX=(configsCam[i-1-j].posX+configsCam[i-2-j].posX)/2.0;
					countDown=0;
				}
				configsLisse[countVal++].posX=configsCam[i].posX; // simplement.. a ne pas oublier !
			}
			else {
				// simple montee :
				if (countDown>0) {
					// on moyenne sur les descentes :
					for (int j=countDown-1; j>=0; j--)
						configsLisse[countVal++].posX=(configsCam[i-1-j].posX+configsCam[i-2-j].posX)/2.0;
					countDown=0;
				}
				countUp++;
			}
		}
		else {
			if (fabs(configsCam[i].posX-lastVal)>=SEUIL_LISS) {
				// saut : 
				if (countDown>0) {
					// on moyenne sur les descentes :
					for (int j=countDown-1; j>=0; j--)
						configsLisse[countVal++].posX=(configsCam[i-1-j].posX+configsCam[i-2-j].posX)/2.0;
					countDown=0;
				}
				else if (countUp>0) {
					// on moyenne sur les montees :
					for (int j=countUp-1; j>=0; j--)
						configsLisse[countVal++].posX=(configsCam[i-1-j].posX+configsCam[i-2-j].posX)/2.0;
					countUp=0;
				}
				configsLisse[countVal++].posX=configsCam[i].posX; // simplement.. a ne pas oublier !
			}
			else {
				// simple descente :
				if (countUp>0) {
					// on moyenne sur les montees :
					for (int j=countUp-1; j>=0; j--)
						configsLisse[countVal++].posX=(configsCam[i-1-j].posX+configsCam[i-2-j].posX)/2.0;
					countUp=0;
				}
				countDown++;
			}
		}
		lastVal=configsCam[i].posX;
	}
	// eventuellement completion des valeurs (si que des montees / ou descentes pour finir)
	if (countVal<(int)configsCam.size()-1) {
		int tmp=max(countUp,countDown);
		for (int j=tmp-1; j>=0; j--)
			configsLisse[countVal++].posX=(configsCam[configsCam.size()-1-j].posX+configsCam[configsCam.size()-2-j].posX)/2.0;
	}
	// ajout eventuel de la derniere valeur,
	// car on a pris n points pour obtenir n-1 valeurs (milieux des segments) :
	if (countVal<(int)configsLisse.size()) configsLisse[countVal].posX=configsCam.back().posX;

	// Pour Y :
	
	countUp=0; // reinitialisations
	countDown=0;
	countVal=0;
	if (configsCam[0].posY<=configsCam[1].posY) countUp++;
	else countDown++;
	// on suppose qu'il n'y a pas de saut a ce stade (!)
	lastVal=configsCam[1].posY;
	for (int i=2; i<(int)configsCam.size(); i++) {
		if (configsCam[i].posY>=lastVal) {
			if (fabs(configsCam[i].posY-lastVal)>=SEUIL_LISS) {
				// saut : 
				if (countUp>0) {
					// on moyenne sur les montees :
					for (int j=countUp-1; j>=0; j--)
						configsLisse[countVal++].posY=(configsCam[i-1-j].posY+configsCam[i-2-j].posY)/2.0;
					countUp=0;
				}
				else if (countDown>0) {
					// on moyenne sur les descentes :
					for (int j=countDown-1; j>=0; j--)
						configsLisse[countVal++].posY=(configsCam[i-1-j].posY+configsCam[i-2-j].posY)/2.0;
					countDown=0;
				}
				configsLisse[countVal++].posY=configsCam[i].posY; // simplement.. a ne pas oublier !
			}
			else {
				// simple montee :
				if (countDown>0) {
					// on moyenne sur les descentes :
					for (int j=countDown-1; j>=0; j--)
						configsLisse[countVal++].posY=(configsCam[i-1-j].posY+configsCam[i-2-j].posY)/2.0;
					countDown=0;
				}
				countUp++;
			}
		}
		else {
			if (fabs(configsCam[i].posY-lastVal)>=SEUIL_LISS) {
				// saut : 
				if (countDown>0) {
					// on moyenne sur les descentes :
					for (int j=countDown-1; j>=0; j--)
						configsLisse[countVal++].posY=(configsCam[i-1-j].posY+configsCam[i-2-j].posY)/2.0;
					countDown=0;
				}
				else if (countUp>0) {
					// on moyenne sur les montees :
					for (int j=countUp-1; j>=0; j--)
						configsLisse[countVal++].posY=(configsCam[i-1-j].posY+configsCam[i-2-j].posY)/2.0;
					countUp=0;
				}
				configsLisse[countVal++].posY=configsCam[i].posY; // simplement.. a ne pas oublier !
			}
			else {
				// simple descente :
				if (countUp>0) {
					// on moyenne sur les montees :
					for (int j=countUp-1; j>=0; j--)
						configsLisse[countVal++].posY=(configsCam[i-1-j].posY+configsCam[i-2-j].posY)/2.0;
					countUp=0;
				}
				countDown++;
			}
		}
		lastVal=configsCam[i].posY;
	}
	// eventuellement completion des valeurs (si que des montees / ou descentes pour finir)
	if (countVal<(int)configsCam.size()-1) {
		int tmp=max(countUp,countDown);
		for (int j=tmp-1; j>=0; j--)
			configsLisse[countVal++].posY=(configsCam[configsCam.size()-1-j].posY+configsCam[configsCam.size()-2-j].posY)/2.0;
	}
	// ajout eventuel de la derniere valeur,
	// car on a pris n points pour obtenir n-1 valeurs (milieux des segments) :
	if (countVal<(int)configsLisse.size()) configsLisse[countVal].posY=configsCam.back().posY;
	
	// Pour Z :
	
	countUp=0; // reinitialisations
	countDown=0;
	countVal=0;
	if (configsCam[0].posZ<=configsCam[1].posZ) countUp++;
	else countDown++;
	// on suppose qu'il n'y a pas de saut a ce stade (!)
	lastVal=configsCam[1].posZ;
	for (int i=2; i<(int)configsCam.size(); i++) {
		if (configsCam[i].posZ>=lastVal) {
			if (fabs(configsCam[i].posZ-lastVal)>=SEUIL_LISS) {
				// saut : 
				if (countUp>0) {
					// on moyenne sur les montees :
					for (int j=countUp-1; j>=0; j--)
						configsLisse[countVal++].posZ=(configsCam[i-1-j].posZ+configsCam[i-2-j].posZ)/2.0;
					countUp=0;
				}
				else if (countDown>0) {
					// on moyenne sur les descentes :
					for (int j=countDown-1; j>=0; j--)
						configsLisse[countVal++].posZ=(configsCam[i-1-j].posZ+configsCam[i-2-j].posZ)/2.0;
					countDown=0;
				}
				configsLisse[countVal++].posZ=configsCam[i].posZ; // simplement.. a ne pas oublier !
			}
			else {
				// simple montee :
				if (countDown>0) {
					// on moyenne sur les descentes :
					for (int j=countDown-1; j>=0; j--)
						configsLisse[countVal++].posZ=(configsCam[i-1-j].posZ+configsCam[i-2-j].posZ)/2.0;
					countDown=0;
				}
				countUp++;
			}
		}
		else {
			if (fabs(configsCam[i].posZ-lastVal)>=SEUIL_LISS) {
				// saut : 
				if (countDown>0) {
					// on moyenne sur les descentes :
					for (int j=countDown-1; j>=0; j--)
						configsLisse[countVal++].posZ=(configsCam[i-1-j].posZ+configsCam[i-2-j].posZ)/2.0;
					countDown=0;
				}
				else if (countUp>0) {
					// on moyenne sur les montees :
					for (int j=countUp-1; j>=0; j--)
						configsLisse[countVal++].posZ=(configsCam[i-1-j].posZ+configsCam[i-2-j].posZ)/2.0;
					countUp=0;
				}
				configsLisse[countVal++].posZ=configsCam[i].posZ; // simplement.. a ne pas oublier !
			}
			else {
				// simple descente :
				if (countUp>0) {
					// on moyenne sur les montees :
					for (int j=countUp-1; j>=0; j--)
						configsLisse[countVal++].posZ=(configsCam[i-1-j].posZ+configsCam[i-2-j].posZ)/2.0;
					countUp=0;
				}
				countDown++;
			}
		}
		lastVal=configsCam[i].posZ;
	}
	// eventuellement completion des valeurs (si que des montees / ou descentes pour finir)
	if (countVal<(int)configsCam.size()-1) {
		int tmp=max(countUp,countDown);
		for (int j=tmp-1; j>=0; j--)
			configsLisse[countVal++].posZ=(configsCam[configsCam.size()-1-j].posZ+configsCam[configsCam.size()-2-j].posZ)/2.0;
	}
	// ajout eventuel de la derniere valeur,
	// car on a pris n points pour obtenir n-1 valeurs (milieux des segments) :
	if (countVal<(int)configsLisse.size()) configsLisse[countVal].posZ=configsCam.back().posZ;

	// Enfin, calcul des angles de rotation de chaque configuration :
	double* vecteur=(double*)malloc(3*sizeof(double));
	for (int i=configsCam.size()-1; i>=0; i--) {
		configsLisse[i].zoom=configsCam[i].zoom;
		configsLisse[i].roll=configsCam[i].roll;
		coord3D=configurations[i].conf2coord3D();
		getRepPoint(i);
		vecteur[0]=currPR[0]-configsLisse[i].posX;
		vecteur[1]=currPR[1]-configsLisse[i].posY;
		vecteur[2]=currPR[2]-configsLisse[i].posZ;
		getSphericAngles(vecteur,configsLisse[i].anglePlan,configsLisse[i].angleVert);
	}
	free(vecteur);
	
	return configsLisse;
}
