#include "ZonesToIdioms.h"

// fonction effectuant le decoupage de la trajectoire selon les zones visitees par le centre de gravite,
// et retournant la suite d'idiomes correspondante
vector<Idiom> idiomsFromZones(const vector<Configuration>& configurations) {
	int lastZoneIndex=-2,j;
	vector<Idiom> resIdioms; // le resultat..

	for (int i=0; i<(int)configurations.size(); i++) {
		// calcul du centre de gravite :
		double* currCG=(double*)malloc(3*sizeof(double));
		coord3D=configurations[i].conf2coord3D();
		currCG[0]=(COEFF_EP*((coord3D[0]+coord3D[3])/2)+COEFF_CO*((coord3D[3]+coord3D[6])/2)+COEFF_PO*coord3D[6])
					/(COEFF_EP+COEFF_CO+COEFF_PO);
		currCG[1]=(COEFF_EP*((coord3D[1]+coord3D[4])/2)+COEFF_CO*((coord3D[4]+coord3D[7])/2)+COEFF_PO*coord3D[7])
					/(COEFF_EP+COEFF_CO+COEFF_PO);
		currCG[2]=(COEFF_EP*((coord3D[2]+coord3D[5])/2)+COEFF_CO*((coord3D[5]+coord3D[8])/2)+COEFF_PO*coord3D[8])
					/(COEFF_EP+COEFF_CO+COEFF_PO);
		
		for (j=zonesBase.size()-1; j>=0; j--) {
			if (zonesBase[j].isInside(currCG)) {
				if (lastZoneIndex==-2) {
					// cas initial
					resIdioms.push_back(idiomsBase[j]); // j A CORRIGER !!!
														// IMPRECIS / INACHEVE
					resIdioms.back().shots[0].firstInd=i;
					// on ne peut pas encore donner l'indice de fin : ce sera fait dans la zone suivante.
				}
				else if (j!=lastZoneIndex) {
					decoupageZ.push_back(i);
					resIdioms.push_back(idiomsBase[j]); // j A CORRIGER !!!
														// IMPRECIS / INACHEVE
					resIdioms.back().shots[0].firstInd=i;
					// on ne peut pas encore donner l'indice de fin : ce sera fait dans la zone suivante.
					if (resIdioms.size()>=2)
						resIdioms[resIdioms.size()-2].shots.back().lastInd=i-1;
				}
				lastZoneIndex=j;
				break;
			}
		}
		if (j<0) {
			// aucune zone correspond a la position du centre de gravite : zone neutre
			if (lastZoneIndex==-2) {
				// cas initial
				resIdioms.push_back(idiomsBase[0]); // -1 A CORRIGER !!!
													// IMPRECIS / INACHEVE
				resIdioms.back().shots[0].firstInd=i;
				// on ne peut pas encore donner l'indice de fin : ce sera fait dans la zone suivante.
			}
			else if (lastZoneIndex>=0) {
				decoupageZ.push_back(i);
				resIdioms.push_back(idiomsBase[0]); // -1 A CORRIGER !!!
													// IMPRECIS / INACHEVE
				resIdioms.back().shots[0].firstInd=i;
				// on ne peut pas encore donner l'indice de fin : ce sera fait dans la zone suivante.
				if (resIdioms.size()>=2)
					resIdioms[resIdioms.size()-2].shots.back().lastInd=i-1;
			}
			lastZoneIndex=-1;
		}
	}

	return resIdioms;
}
