#ifndef _ConfigCamera
#define _ConfigCamera

#include <cstdlib>

// classe de stockage des parametres d'une cam a un instant donne;
// on utilise un point cible au lieu des deux angles phi et theta, comme dans RT

class ConfigCamera {
	
public :
	
	ConfigCamera (double posX=0.0,double posY=0.0,double posZ=0.0,double posCx=0.0,double posCy=0.0,double posCz=0.0,double roll=0.0,double zoom=1.0) {
		this->posX=posX;
		this->posY=posY;
		this->posZ=posZ;
		this->posCx=posCx;
		this->posCy=posCy;
		this->posCz=posCz;
		this->roll=roll;
		this->zoom=zoom;
	}
	
	ConfigCamera (const ConfigCamera& confCam) {
		posX=confCam.posX;
		posY=confCam.posY;
		posZ=confCam.posZ;
		posCx=confCam.posCx;
		posCy=confCam.posCy;
		posCz=confCam.posCz;
		roll=confCam.roll;
		zoom=confCam.zoom;
	}
	
	~ConfigCamera () {}
	
	double posX,posY,posZ; // position spatiale du centre de gravite
	double posCx,posCy,posCz;
	double roll;
	double zoom; // force du zoom (1.0 pour normal)

};

#endif
