#ifndef _Idiom
#define _Idiom

#include <cstdlib>
#include <vector>

using namespace std;

// description d'un shot
struct Shot {
	Shot (int t=0,int f=0, int l=0) {
		type=t;
		firstInd=f;
		lastInd=l;
	}
	Shot (const Shot& sh) {
		type=sh.type;
		firstInd=sh.firstInd;
		lastInd=sh.lastInd;
	}
	int type; /* type de shot, 0==static / go-by,
							   1==pan horizontal,
							   2==pan vertical,
							   3==track,
							   4==follow,
							   5==aerien. */
	int firstInd,lastInd; // indices de debut et de fin d'application du shot
};

// description d'un idiome : simplement un vecteur de shots avec timeStamps relatifs (firstInd,lastInd) non initialises
struct Idiom {
	Idiom () {}
	Idiom (const Idiom& idi) {
		name=idi.name; // copie de pointeur : OK car les noms servent juste comme idendifiants eventuels
		shots=idi.shots;
		for (int i=0; i<(int)idi.views.size(); i++) views.push_back(idi.views[i]);
	}

	char* name;
	vector<Shot> shots;
	vector<int> views; // hierarchie des angles de vue privilegies (voir memoire)
						// initialise lors de la transformation du chemin en idiomes.
};

#endif
