// classe ajustant localement l'emplacement de la camera (une seule camera)

#include "PlaceCamera.h"
#include <iostream>

using namespace std;

// initialise la position d'une camera : (INITIALISE AUSSI LES ANGLES)
void PlaceCamera::initCamPos(int indexCam) {
	// d'abord le cas ou l'on doit zoomer sur une region specifique car passage proche d'un obstacle :
	if (zoomObstPoints[indiceG] && !handPoints[indiceG]) {
		initPos_Obstacle(indexCam);
	}
	else {
		// cas de zoom sur la main ou filmage du bras entier :
		if (indexCam==1) initPos_CG_Arm1();
		else if (indexCam==0) initPos_CG_Arm0();
		else initPos_CG_Arm2();
	}

	// on calcule enfin les angles :
	Camera* cam=&cameras[indexCam];
	double vectCamPR[]={currPR[0]-(*cam).posX,currPR[1]-(*cam).posY,currPR[2]-(*cam).posZ};
	getSphericAngles(vectCamPR,(*cam).anglePlan,(*cam).angleVert);
	
	// reglage du roll : (?!)
	(*cam).roll=0.0;
	// reglage du zoom : on le met toujours a 1 et on fait plutot varier la distance de la camera au point de repere,
	// pour l'instant.
	(*cam).zoom=1.0;

	return;
}

// micro-fonctions : separation utile lors de la compilation finale des idiomes.
// on aura en effet besoin seulement de la seconde partie de la fonction.
void PlaceCamera::testBestAngles(double* positionCam,double& visibilite,int indexCam) {
	Camera* cam=&cameras[indexCam];
	double tmpVis;
	visibilite=0.0;

	if (indexCam==1) {
		for (int i=0; i<NB_VIEWS; i++) {
			tmpVis=testView(*cam,i);
			if (tmpVis>visibilite) {
				positionCam[0]=(*cam).posX;
				positionCam[1]=(*cam).posY;
				positionCam[2]=(*cam).posZ;
				visibilite=tmpVis;
				viewsCam[1]=i;
			}
		}
	}
	else if (indexCam==0) {
		for (int i=viewsCam[1]+1; i<NB_VIEWS; i++) {
			tmpVis=testView(*cam,i);
			if (tmpVis>visibilite) {
				positionCam[0]=(*cam).posX;
				positionCam[1]=(*cam).posY;
				positionCam[2]=(*cam).posZ;
				visibilite=tmpVis;
				viewsCam[0]=i;
			}
		}
	}
	else {
		for (int i=viewsCam[0]+1; i<NB_VIEWS; i++) {
			tmpVis=testView(*cam,i);
			if (tmpVis>visibilite) {
				positionCam[0]=(*cam).posX;
				positionCam[1]=(*cam).posY;
				positionCam[2]=(*cam).posZ;
				visibilite=tmpVis;
				viewsCam[2]=i;
			}
		}
	}
	
	return;
}

// renvoit une vue correcte mais aleatoirement placee (utile pr la compilation)
void PlaceCamera::getAleaView(int indexCam) {
	Camera* cam=&cameras[indexCam];
	double memX=(*cam).posX,memY=(*cam).posY,memZ=(*cam).posZ;
	double visibilite=0.0;
	int compteur=0;
	
	if (indexCam==1) {
		double bestVis=0.0;
		while (visibilite<SEUIL_VIS_INIT && compteur++ < MAX_TRIAL_VIS) {
			randomSelectOnSphere(1);
			visibilite=(*cam).getVisibilite();
			if (visibilite>bestVis) {
				bestVis=visibilite;
				memX=(*cam).posX;
				memY=(*cam).posY;
				memZ=(*cam).posZ;
			}
		}
		(*cam).posX=memX;
		(*cam).posY=memY;
		(*cam).posZ=memZ;
	}
	else if (indexCam==0) {
		double distance=sqrt(((*cam).posX-cameras[1].posX)*((*cam).posX-cameras[1].posX)
							+ ((*cam).posY-cameras[1].posY)*((*cam).posY-cameras[1].posY)
							+ ((*cam).posZ-cameras[1].posZ)*((*cam).posZ-cameras[1].posZ));
		double bestSum=0.0,tmp;
		while (visibilite<SEUIL_VIS_INIT && distance<distCamPR && compteur++ < MAX_TRIAL_VIS) {
			randomSelectOnSphere(0);
			visibilite=(*cam).getVisibilite();
			distance=sqrt(((*cam).posX-cameras[1].posX)*((*cam).posX-cameras[1].posX)
						+ ((*cam).posY-cameras[1].posY)*((*cam).posY-cameras[1].posY)
						+ ((*cam).posZ-cameras[1].posZ)*((*cam).posZ-cameras[1].posZ));
			tmp=distCamPR*visibilite+distance;
			if (tmp>bestSum) {
				bestSum=tmp;
				memX=(*cam).posX;
				memY=(*cam).posY;
				memZ=(*cam).posZ;
			}
		}
		(*cam).posX=memX;
		(*cam).posY=memY;
		(*cam).posZ=memZ;
	}
	else {
		double distance1=sqrt(((*cam).posX-cameras[1].posX)*((*cam).posX-cameras[1].posX)
							+ ((*cam).posY-cameras[1].posY)*((*cam).posY-cameras[1].posY)
							+ ((*cam).posZ-cameras[1].posZ)*((*cam).posZ-cameras[1].posZ));
		double distance0=sqrt(((*cam).posX-cameras[0].posX)*((*cam).posX-cameras[0].posX)
							+ ((*cam).posY-cameras[0].posY)*((*cam).posY-cameras[0].posY)
							+ ((*cam).posZ-cameras[0].posZ)*((*cam).posZ-cameras[0].posZ));
		double bestSum=0.0,tmp;
		while (visibilite<SEUIL_VIS_INIT && distance1+distance0<1.4*distCamPR && compteur++ < MAX_TRIAL_VIS) { // 1.4 : A AJUSTER
			randomSelectOnSphere(2);
			visibilite=(*cam).getVisibilite();
			distance1=sqrt(((*cam).posX-cameras[1].posX)*((*cam).posX-cameras[1].posX)
						+ ((*cam).posY-cameras[1].posY)*((*cam).posY-cameras[1].posY)
						+ ((*cam).posZ-cameras[1].posZ)*((*cam).posZ-cameras[1].posZ));
			distance0=sqrt(((*cam).posX-cameras[0].posX)*((*cam).posX-cameras[0].posX)
						+ ((*cam).posY-cameras[0].posY)*((*cam).posY-cameras[0].posY)
						+ ((*cam).posZ-cameras[0].posZ)*((*cam).posZ-cameras[0].posZ));
			tmp=distCamPR*visibilite+distance1+distance0;
			if (tmp>bestSum) {
				bestSum=tmp;
				memX=(*cam).posX;
				memY=(*cam).posY;
				memZ=(*cam).posZ;
			}
		}
		(*cam).posX=memX;
		(*cam).posY=memY;
		(*cam).posZ=memZ;
	}
	
	return;
}

/*******************************************
* fonctions auxiliaires d'initialisation :
********************************************/

// fonction 1 : camera centrale
void PlaceCamera::initPos_CG_Arm1() {
	Camera* cam=&cameras[1];
	double visibilite;
	double* positionCam=(double*)malloc(3*sizeof(double));

	// teste d'abord les meilleures vues preselectionnees :
	testBestAngles(positionCam,visibilite,1);

	// sinon : vue aleatoire
	if (visibilite<SEUIL_VIS_INIT)
		getAleaView(1);
	else {
		(*cam).posX=positionCam[0];
		(*cam).posY=positionCam[1];
		(*cam).posZ=positionCam[2];
	}

	free(positionCam);
	
	// maintenant il faut peut etre corriger les positions des deux autres cameras en cascade 
	// si celles-ci ont une meilleure vue ; cas rare mais possible :
	if (viewsCam[0]<=viewsCam[1]) initPos_CG_Arm0();

	return;
}

// fonction 0 : camera de gauche
void PlaceCamera::initPos_CG_Arm0() {
	Camera* cam=&cameras[0];
	double visibilite;
	double* positionCam=(double*)malloc(3*sizeof(double));
	
	// teste d'abord les meilleures vues preselectionnees :
	testBestAngles(positionCam,visibilite,0);

	// sinon : vue aleatoire
	if (visibilite<SEUIL_VIS_INIT)
		getAleaView(0);
	else {
		(*cam).posX=positionCam[0];
		(*cam).posY=positionCam[1];
		(*cam).posZ=positionCam[2];
	}
	
	free(positionCam);
	
	// maintenant il faut peut etre corriger la position de la derniere camera
	// si celle-ci a une meilleure vue ; cas rare mais possible :
	if (viewsCam[2]<=viewsCam[0]) initPos_CG_Arm2();

	return;
}

// fonction 2 : camera de droite
void PlaceCamera::initPos_CG_Arm2() {
	Camera* cam=&cameras[2];
	double visibilite;
	double* positionCam=(double*)malloc(3*sizeof(double));
	
	// teste d'abord les meilleures vues preselectionnees :
	testBestAngles(positionCam,visibilite,2);

	// sinon : vue aleatoire
	if (visibilite<SEUIL_VIS_INIT)
		getAleaView(2);
	else {
		(*cam).posX=positionCam[0];
		(*cam).posY=positionCam[1];
		(*cam).posZ=positionCam[2];
	}

	free(positionCam);

	return;
}

// fonction auxiliaire d'initialisation [2] : pour point entre bras et obstacle
// inutile de faire 3 fonctions car les positions sont ajustees alors en tenant toujours compte
// de toutes les cameras (pour celles de gauche et droite).
void PlaceCamera::initPos_Obstacle(int indexCam) {
	Camera* cam=&cameras[indexCam];
	double visibilite=0.0;

	if (indexCam==1) {
	
		/*******************************************************************************************
		* on va placer la camera sur le plan mediateur,
		* tel que le vecteur camera->centre du segment fasse un angle minimal (entre 0 et pi/2) avec
		* le vecteur centre de gravite du bras->[orthogonal au plan forme par les 3 joints] */
		
		// calcul des vecteurs directeurs du plan mediateur

		// vecteur centre de gravite->[orthogonal au plan forme par les 3 joints] :
		double* vectCG_O=(double*)malloc(3*sizeof(double));
		bool maximiz=false;
		// si les 3 joints sont colineaires, alors..
		if (colineaires(coord3D,coord3D+3,coord3D+6)) {
			// on cherche dans ce cas a MAXIMISER l'angle avec le vecteur coord3D->coord3D+6
			for (int i=2; i>=0; i--) vectCG_O[i]=coord3D[6+i]-coord3D[i];
			maximiz=true;
		}
		else {
			// on suppose maintenant que les 3 joints ne sont pas colineaires :
			// coordonnees relatives des joints coude et poignet (on prend 1 sur Oz) :
			double cX=coord3D[3]-coord3D[0],cY=coord3D[4]-coord3D[1],cZ=coord3D[5]-coord3D[2],
					cpX=coord3D[6]-coord3D[3],cpY=coord3D[7]-coord3D[4],cpZ=coord3D[8]-coord3D[5];
			// calcul de la direction orthogonale:
			double invDet=1.0/(cY*cpX-cpY*cX);
			vectCG_O[0]=invDet*(cY*cpZ-cZ*cpY);
			vectCG_O[1]=invDet*(cX*cpZ-cZ*cpX);
			vectCG_O[2]=1.0;
		}

		// vecteur orthogonal au plan mediateur :
		double* ortho=(double*)malloc(3*sizeof(double));
		for (int i=2; i>=0; i--) ortho[i]=coordObstacles[indiceG][i]-coordPointsB[indiceG][i];
		// on determine ses angles en coordonnees spheriques :
		double phi,theta;
		getSphericAngles(ortho,phi,theta);
		free(ortho);
		
		// puis on trouve la matrice de passage :
		double *coeffsX=(double*)malloc(3*sizeof(double)),
				*coeffsY=(double*)malloc(3*sizeof(double)),
				*coeffsZ=(double*)malloc(3*sizeof(double));
		getPassMatrix(coeffsX,coeffsY,coeffsZ,phi,theta);
		
		// ainsi, le point recherche est de la forme milieu + R rotation d'angle alpha(coeffsX)
		// par rapport a l'axe "ortho" (orthogonal du plan median),
		// Et l'angle a minimiser (eventuellement maximiser) a pour cosinus :
		// (rotation d'angle alpha(coeffsX)).(vectCG_O) / (||rotation d'angle alpha(coeffsX)||.||vectCG_O||),
		// soit (rotation d'angle alpha(coeffsX)).(vectCG_O) / ||vectCG_O||
		// on veut que cette derniere quantite soit le plus proche possible de 1 (eventuellement 0)
		
		// on commence par calculer les coordonnees parametriques du point obtenu par
		// rotation d'angle alpha(coeffsX) d'axe ortho, avec alpha initialise a 0,
		// puis on incremente alpha petit a petit.
		
		double alpha,valCos,valSin;
		double* interm=(double*)malloc(3*sizeof(double));
		double* interm2=(double*)malloc(3*sizeof(double));
		double prodScal,pNorm,normPVect;
		double *imgPoint, *prodVect=(double*)malloc(3*sizeof(double));

		// copie du vecteur coeffsX :
		double* vectRot=(double*)malloc(3*sizeof(double));
		for (int i=2; i>=0; i--) vectRot[i]=coeffsX[i];

		// algorithme :
		// simplement regarder la valeur en chaque pas,
		// dichotomie impossible car fonction "quasi-monotone" mais PAS monotone
		// methode exacte beaucoup trop lourde a implementer.

		double bestAlpha=0.0,pasAlpha=(2*M_PI)/30; // valeur 30 a regler....
		double bestEcartCos=2.0,bestEcartSin=2.0;
		
		for (alpha=0.0; alpha<=2*M_PI; alpha+=pasAlpha) {
			// on effectue la rotation :
			for (int i=2; i>=0; i--) vectRot[i]=coeffsX[i];
			imgPoint=rotatePoint(coeffsX,coeffsY,coeffsZ,alpha,vectRot);
			
			// produit scalaire :
			prodScal=imgPoint[0]*vectCG_O[0]+imgPoint[1]*vectCG_O[1]+imgPoint[2]*vectCG_O[2];
			// norme de vectCG_O :
			pNorm=sqrt(vectCG_O[0]*vectCG_O[0]+vectCG_O[1]*vectCG_O[1]+vectCG_O[2]*vectCG_O[2]);
			
			// on en deduit le cosinus :
			valCos=prodScal/pNorm;
			
			// .. et le sinus via un produit vectoriel :
			prodVect[0]=imgPoint[1]*vectCG_O[2]-imgPoint[2]*vectCG_O[1];
			prodVect[1]=imgPoint[2]*vectCG_O[0]-imgPoint[0]*vectCG_O[2];
			prodVect[2]=imgPoint[0]*vectCG_O[1]-imgPoint[1]*vectCG_O[0];
			normPVect=sqrt(prodVect[0]*prodVect[0]+prodVect[1]*prodVect[1]+prodVect[2]*prodVect[2]);
			valSin=normPVect/pNorm;
			
			// mise a jour des variables :
			if (!maximiz && 1-fabs(valCos)<bestEcartCos && fabs(valSin)<bestEcartSin) {
				bestAlpha=alpha;
				bestEcartCos=1-fabs(valCos);
				bestEcartSin=fabs(valSin);
			}
			else if (maximiz && fabs(valCos)<bestEcartCos && 1-fabs(valSin)<bestEcartSin) {
				bestAlpha=alpha;
				bestEcartCos=fabs(valCos);
				bestEcartSin=1-fabs(valSin);
			}
		}

		free(interm);
		free(interm2);
		free(prodVect);
		free(vectCG_O);
		
		// on obtient finalement la meilleure valeure trouvee :
		alpha=bestAlpha;
		
		// on en deduit le vecteur de vue par rotation de coeffsX :
		for (int i=2; i>=0; i--) vectRot[i]=coeffsX[i];
		imgPoint=rotatePoint(coeffsX,coeffsY,coeffsZ,alpha,vectRot);

		// point milieu :
		double* milieu=(double*)malloc(3*sizeof(double));
		for (int i=2; i>=0; i--) milieu[i]=(coordPointsB[indiceG][i]+coordObstacles[indiceG][i])/2;
		
		// normalisation :
		double factNorm=distCamPR/
			sqrt((milieu[0]-imgPoint[0])*(milieu[0]-imgPoint[0])
				+ (milieu[1]-imgPoint[1])*(milieu[1]-imgPoint[1])
				+ (milieu[2]-imgPoint[2])*(milieu[2]-imgPoint[2]));
		(*cam).posX=milieu[0]+(imgPoint[0]-milieu[0])*factNorm;
		(*cam).posY=milieu[1]+(imgPoint[1]-milieu[1])*factNorm;
		(*cam).posZ=milieu[2]+(imgPoint[2]-milieu[2])*factNorm;
		
		// liberations memoire :
		free(coeffsZ);
		free(imgPoint);
		free(vectRot);
		free(milieu);
		
		visibilite=(*cam).getVisibilite();

// DEBUG :
//cout << "visibilite OBST  " << visibilite << "   " << indiceG << endl;
		
		/*************************************************************************************
		* si cette vue n'est pas satisfaisante, alors on selectionne un point aleatoire sur le cercle,
		* comme dans randomSelectOnSphere(), restreinte a un cercle de vision. */

		if (visibilite<SEUIL_VIS_INIT) {
			int compteur=0;
			double memX=0.0,memY=0.0,memZ=0.0,bestVis=visibilite;
			while (visibilite<SEUIL_VIS_INIT && compteur++ < 100) {
				randomSelectOnCircle(1,coeffsX,coeffsY);
				visibilite=(*cam).getVisibilite();
				if (visibilite>bestVis) {
					bestVis=visibilite;
					memX=(*cam).posX;
					memY=(*cam).posY;
					memZ=(*cam).posZ;
				}
			}
			(*cam).posX=memX;
			(*cam).posY=memY;
			(*cam).posZ=memZ;
		}
		free(coeffsX);
		free(coeffsY);
	}

	else if (indexCam==0) {
		// on selectionne une vue aleatoire sur le cercle de vision,
		// assez eloigne de la vue centrale	:
		
		// vecteur orthogonal au plan mediateur :
		double* ortho=(double*)malloc(3*sizeof(double));
		for (int i=2; i>=0; i--) ortho[i]=coordObstacles[indiceG][i]-coordPointsB[indiceG][i];
		// on determine ses angles en coordonnees spheriques :
		double phi,theta;
		getSphericAngles(ortho,phi,theta);
		free(ortho);
		
		// on en deduit coeffsX et coeffsY :
		double* coeffsX=(double*)malloc(3*sizeof(double));
		double* coeffsY=(double*)malloc(3*sizeof(double));
		double tmpCosP=cos(phi),tmpSinP=sin(phi);
		double tmpCosV=cos(theta);
		coeffsX[0]=tmpCosP*tmpCosV;
		coeffsX[1]=tmpSinP*tmpCosV;
		coeffsX[2]=-sin(theta);
		coeffsY[0]=-tmpSinP;
		coeffsY[1]=tmpCosP;
		coeffsY[2]=0.0;
		
		// puis notre point aleatoire, jusqu'a avoir une vue satisfaisante :
		double distance=sqrt(((*cam).posX-cameras[1].posX)*((*cam).posX-cameras[1].posX)
							+ ((*cam).posY-cameras[1].posY)*((*cam).posY-cameras[1].posY)
							+ ((*cam).posZ-cameras[1].posZ)*((*cam).posZ-cameras[1].posZ));
		int compteur=0;
		double memX=(*cam).posX,memY=(*cam).posY,memZ=(*cam).posZ,bestSum=0.0,tmp;
		while (visibilite<SEUIL_VIS_INIT && distance<distCamPR && compteur++ < MAX_TRIAL_VIS) {
			randomSelectOnCircle(0,coeffsX,coeffsY);
			visibilite=(*cam).getVisibilite();
			distance=sqrt(((*cam).posX-cameras[1].posX)*((*cam).posX-cameras[1].posX)
						+ ((*cam).posY-cameras[1].posY)*((*cam).posY-cameras[1].posY)
						+ ((*cam).posZ-cameras[1].posZ)*((*cam).posZ-cameras[1].posZ));
			tmp=distCamPR*visibilite+distance;
			if (tmp>bestSum) {
				bestSum=tmp;
				memX=(*cam).posX;
				memY=(*cam).posY;
				memZ=(*cam).posZ;
			}
		}
		(*cam).posX=memX;
		(*cam).posY=memY;
		(*cam).posZ=memZ;
		
		free(coeffsX);
		free(coeffsY);
	}
	
	else {
		// on selectionne une vue aleatoire sur le cercle de vision,
		// le plus eloigne possible des 2 autres vues :
		
		// vecteur orthogonal au plan mediateur :
		double* ortho=(double*)malloc(3*sizeof(double));
		for (int i=2; i>=0; i--) ortho[i]=coordObstacles[indiceG][i]-coordPointsB[indiceG][i];
		// on determine ses angles en coordonnees spheriques :
		double phi,theta;
		getSphericAngles(ortho,phi,theta);
		free(ortho);
		
		// on en deduit coeffsX et coeffsY :
		double* coeffsX=(double*)malloc(3*sizeof(double));
		double* coeffsY=(double*)malloc(3*sizeof(double));
		double tmpCosP=cos(phi),tmpSinP=sin(phi);
		double tmpCosV=cos(theta);
		coeffsX[0]=tmpCosP*tmpCosV;
		coeffsX[1]=tmpSinP*tmpCosV;
		coeffsX[2]=-sin(theta);
		coeffsY[0]=-tmpSinP;
		coeffsY[1]=tmpCosP;
		coeffsY[2]=0.0;
		
		// puis point aleatoire sur cercle :
		double distance1=sqrt(((*cam).posX-cameras[1].posX)*((*cam).posX-cameras[1].posX)
							+ ((*cam).posY-cameras[1].posY)*((*cam).posY-cameras[1].posY)
							+ ((*cam).posZ-cameras[1].posZ)*((*cam).posZ-cameras[1].posZ));
		double distance0=sqrt(((*cam).posX-cameras[0].posX)*((*cam).posX-cameras[0].posX)
							+ ((*cam).posY-cameras[0].posY)*((*cam).posY-cameras[0].posY)
							+ ((*cam).posZ-cameras[0].posZ)*((*cam).posZ-cameras[0].posZ));
		int compteur=0;
		double memX=(*cam).posX,memY=(*cam).posY,memZ=(*cam).posZ,bestSum=0.0,tmp;
		while (visibilite<SEUIL_VIS_INIT && distance1+distance0<1.4*distCamPR && compteur++ < MAX_TRIAL_VIS) { // 1.4 : A AJUSTER
			randomSelectOnCircle(2,coeffsX,coeffsY);
			visibilite=(*cam).getVisibilite();
			distance1=sqrt(((*cam).posX-cameras[1].posX)*((*cam).posX-cameras[1].posX)
						+ ((*cam).posY-cameras[1].posY)*((*cam).posY-cameras[1].posY)
						+ ((*cam).posZ-cameras[1].posZ)*((*cam).posZ-cameras[1].posZ));
			distance0=sqrt(((*cam).posX-cameras[0].posX)*((*cam).posX-cameras[0].posX)
						+ ((*cam).posY-cameras[0].posY)*((*cam).posY-cameras[0].posY)
						+ ((*cam).posZ-cameras[0].posZ)*((*cam).posZ-cameras[0].posZ));
			tmp=distCamPR*visibilite+distance1+distance0;
			if (tmp>bestSum) {
				bestSum=tmp;
				memX=(*cam).posX;
				memY=(*cam).posY;
				memZ=(*cam).posZ;
			}
		}
		(*cam).posX=memX;
		(*cam).posY=memY;
		(*cam).posZ=memZ;
		
		free(coeffsX);
		free(coeffsY);
	}
	
	return;
}

/**************************************************
* fin des fonctions auxiliaires d'initialisation
***************************************************/

// selection aleatoire d'une position de la camera sur la sphere de vision du bras :
// (INITIALISE PAS LES ANGLES)
void PlaceCamera::randomSelectOnCircle(int indexCam,double* coeffsX,double* coeffsY) {
	Camera* cam=&cameras[indexCam];
	double* posCam=(double*)calloc(3,sizeof(double));
	double coord0,coord1,coord2;

	do {
		double depctX=randBit()*genAlea(),depctY=randBit()*genAlea(),factNorm;
		coord0=depctX*coeffsX[0]+depctY*coeffsY[0];
		coord1=depctX*coeffsX[1]+depctY*coeffsY[1];
		coord2=depctX*coeffsX[2]+depctY*coeffsY[2];
		factNorm=distCamPR/sqrt(coord0*coord0+coord1*coord1+coord2*coord2);
		(*cam).posX=currPR[0]+factNorm*coord0;
		(*cam).posY=currPR[1]+factNorm*coord1;
		(*cam).posZ=currPR[2]+factNorm*coord2;
		posCam[0]=(*cam).posX;
		posCam[1]=(*cam).posY;
		posCam[2]=(*cam).posZ;
	}
	while (collisionBen(posCam));

	free(posCam);
	return;
}

// selection aleatoire d'une position de la camera sur la sphere de vision du bras :
// (INITIALISE PAS LES ANGLES)
void PlaceCamera::randomSelectOnSphere(int indexCam) {
	Camera* cam=&cameras[indexCam];
	double* posCam=(double*)calloc(3,sizeof(double));

	do {
		double depctX=randBit()*genAlea(),depctY=randBit()*genAlea(),depctZ=randBit()*genAlea(),factNorm;
		factNorm=distCamPR/sqrt(depctX*depctX+depctY*depctY+depctZ*depctZ);
		(*cam).posX=currPR[0]+depctX*factNorm;
		(*cam).posY=currPR[1]+depctY*factNorm;
		(*cam).posZ=currPR[2]+depctZ*factNorm;
		posCam[0]=(*cam).posX;
		posCam[1]=(*cam).posY;
		posCam[2]=(*cam).posZ;
	}
	while (collisionBen(posCam));

	free(posCam);
	return;
}

// ajuste la position de la camera :
// (MET A JOUR LES ANGLES)
void PlaceCamera::adjustCamPos(int indexCam) {
	Camera* cam=&cameras[indexCam];

	// plus on est proche d'un point de coupure (obstacles) et plus on va exiger une bonne vue de la camera :
	// (on utilise pas vraiment analyseMonotone, sans grande signification pour l'utilisateur)
	int i=0;
	double dist2CutInv=0.0;
	if (!decoupageO.empty()) {
		while (i<(int)decoupageO.size() && decoupageO[i]<indiceG) i++;
		if (i==0) {
			dist2CutInv=1.0/(mini(indiceG,decoupageO[0]-indiceG)+2.1);
		}
		else if (i<(int)decoupageO.size()) {
			dist2CutInv=1.0/(mini(indiceG-decoupageO[i-1],decoupageO[i]-indiceG)+2.1);
		}
	}

	double visibilite=(*cam).getVisibilite();
	if (visibilite<SEUIL_VIS_ADJUST+dist2CutInv) {
		initCamPos(indexCam);
		return;
	}

	// on effectue des deplacements elementaires dans 8 directions,
	// tout en restant environ a meme distance du centre de gravite :
	// (au final la distance n'aura pas change; pour simplifier elle varie legerement pendant les calculs)
	double newVis,oldVis=visibilite;
	int* memStep=(int*)malloc(2*sizeof(int));
	double elemStep=0.0001*sqrt((currPR[0]-(*cam).posX)*(currPR[0]-(*cam).posX)
						+ (currPR[1]-(*cam).posY)*(currPR[1]-(*cam).posY)
						+ (currPR[2]-(*cam).posZ)*(currPR[2]-(*cam).posZ)); // 0.0001 pr DEBUG !!!! tester..
	
	// on doit avancer dans deux directions orthogonales au vecteur currCG-->cam :
	// mme methode que dans Camera.cpp pour le changement de base.

	double* diffPR_Cam=(double*)malloc(3*sizeof(double));
	diffPR_Cam[0]=currPR[0]-(*cam).posX;
	diffPR_Cam[1]=currPR[1]-(*cam).posY;
	diffPR_Cam[2]=currPR[2]-(*cam).posZ;

	// transformation en coordonnees spheriques pour obtenir phi et theta :
	double phi,theta;
	getSphericAngles(diffPR_Cam,phi,theta);
	free(diffPR_Cam);

	// on en deduit un systeme de 2 vecteurs base orthonormee du plan tangent :
	double tmpSinP=sin(phi),tmpCosP=cos(phi);
	double tmpCosV=cos(theta);
	double* coeffsX=(double*)malloc(3*sizeof(double));
	double* coeffsY=(double*)malloc(3*sizeof(double));
	coeffsX[0]=tmpCosP*tmpCosV;
	coeffsX[1]=tmpSinP*tmpCosV;
	coeffsX[2]=-sin(theta);
	coeffsY[0]=-tmpSinP;
	coeffsY[1]=tmpCosP;
	coeffsY[2]=0.0;

	/*************
	*** X : ******
	*************/

	(*cam).posX+=elemStep*coeffsX[0];
	(*cam).posY+=elemStep*coeffsX[1];
	(*cam).posZ+=elemStep*coeffsX[2];
	newVis=(*cam).getVisibilite();
	if (newVis>visibilite) {
		visibilite=newVis;
		memStep[0]=1;
		memStep[1]=0;
	}
	// et dans l'autre sens :
	(*cam).posX-=2*elemStep*coeffsX[0];
	(*cam).posY-=2*elemStep*coeffsX[1];
	(*cam).posZ-=2*elemStep*coeffsX[2];
	newVis=(*cam).getVisibilite();
	if (newVis>visibilite) {
		visibilite=newVis;
		memStep[0]=-1;
		memStep[1]=0;
	}
	(*cam).posX+=elemStep*coeffsX[0];
	(*cam).posY+=elemStep*coeffsX[1];
	(*cam).posZ+=elemStep*coeffsX[2];
	
	/*************
	*** Y : ******
	*************/

	(*cam).posX+=elemStep*coeffsY[0];
	(*cam).posY+=elemStep*coeffsY[1];
	(*cam).posZ+=elemStep*coeffsY[2];
	newVis=(*cam).getVisibilite();
	if (newVis>visibilite) {
		visibilite=newVis;
		memStep[0]=0;
		memStep[1]=1;
	}
	// et dans l'autre sens :
	(*cam).posX-=2*elemStep*coeffsY[0];
	(*cam).posY-=2*elemStep*coeffsY[1];
	(*cam).posZ-=2*elemStep*coeffsY[2];
	newVis=(*cam).getVisibilite();
	if (newVis>visibilite) {
		visibilite=newVis;
		memStep[0]=0;
		memStep[1]=-1;
	}
	(*cam).posX+=elemStep*coeffsY[0];
	(*cam).posY+=elemStep*coeffsY[1];
	(*cam).posZ+=elemStep*coeffsY[2];
	
	/******************
	*** X et Y : ******
	******************/
	
	// ++ :
	
	(*cam).posX+=elemStep*(coeffsX[0]+coeffsY[0]);
	(*cam).posY+=elemStep*(coeffsX[1]+coeffsY[1]);
	(*cam).posZ+=elemStep*(coeffsX[2]+coeffsY[2]);
	newVis=(*cam).getVisibilite();
	if (newVis>visibilite) {
		visibilite=newVis;
		memStep[0]=1;
		memStep[1]=1;
	}
	// et dans l'autre sens :
	(*cam).posX-=2*elemStep*(coeffsX[0]+coeffsY[0]);
	(*cam).posY-=2*elemStep*(coeffsX[1]+coeffsY[1]);
	(*cam).posZ-=2*elemStep*(coeffsX[2]+coeffsY[2]);
	newVis=(*cam).getVisibilite();
	if (newVis>visibilite) {
		visibilite=newVis;
		memStep[0]=-1;
		memStep[1]=-1;
	}
	(*cam).posX+=elemStep*(coeffsX[0]+coeffsY[0]);
	(*cam).posY+=elemStep*(coeffsX[1]+coeffsY[1]);
	(*cam).posZ+=elemStep*(coeffsX[2]+coeffsY[2]);
	
	// +- :
	
	(*cam).posX+=elemStep*(coeffsX[0]-coeffsY[0]);
	(*cam).posY+=elemStep*(coeffsX[1]-coeffsY[1]);
	(*cam).posZ+=elemStep*(coeffsX[2]-coeffsY[2]);
	newVis=(*cam).getVisibilite();
	if (newVis>visibilite) {
		visibilite=newVis;
		memStep[0]=1;
		memStep[1]=-1;
	}
	// et dans l'autre sens :
	(*cam).posX-=2*elemStep*(coeffsX[0]-coeffsY[0]);
	(*cam).posY-=2*elemStep*(coeffsX[1]-coeffsY[1]);
	(*cam).posZ-=2*elemStep*(coeffsX[2]-coeffsY[2]);
	newVis=(*cam).getVisibilite();
	if (newVis>visibilite) {
		visibilite=newVis;
		memStep[0]=-1;
		memStep[1]=1;
	}
	(*cam).posX+=elemStep*(coeffsX[0]-coeffsY[0]);
	(*cam).posY+=elemStep*(coeffsX[1]-coeffsY[1]);
	(*cam).posZ+=elemStep*(coeffsX[2]-coeffsY[2]);

	if (visibilite>oldVis) {
		(*cam).posX+=elemStep*(memStep[0]*coeffsX[0]+memStep[1]*coeffsY[0]);
		(*cam).posY+=elemStep*(memStep[0]*coeffsX[1]+memStep[1]*coeffsY[1]);
		(*cam).posZ+=elemStep*(memStep[0]*coeffsX[2]+memStep[1]*coeffsY[2]);
		
		// on doit ensuite assurer que la distance de la camera au centre de gravite reste la meme :
		double distA=sqrt(((*cam).posX-currPR[0])*((*cam).posX-currPR[0])
						+ ((*cam).posY-currPR[1])*((*cam).posY-currPR[1])
						+ ((*cam).posZ-currPR[2])*((*cam).posZ-currPR[2]));
		double factNorm=(1-distCamPR/distA);
		(*cam).posX+=factNorm*(currPR[0]-(*cam).posX);
		(*cam).posY+=factNorm*(currPR[1]-(*cam).posY);
		(*cam).posZ+=factNorm*(currPR[2]-(*cam).posZ);
	}
	
	// enfin on recalcule les angles : (normalement deja calcule au moins une fois mais bon..)
	double vecteur[]={currPR[0]-(*cam).posX,currPR[1]-(*cam).posY,currPR[2]-(*cam).posZ};
	getSphericAngles(vecteur,(*cam).anglePlan,(*cam).angleVert);
	
	free(coeffsX);
	free(coeffsY);
	free(memStep);

	return;
}

// pour l'instant on se contente de deplacer la camera en suivant le centre de gravite :
// ensuite il faudra eventuellement prendre en compte l'effet inertiel.
// (INITIALISE PAS LES ANGLES)
void PlaceCamera::moveCamera(double* depctRepPoint,int indexCam) {
	Camera* cam=&cameras[indexCam];

	(*cam).posX+=depctRepPoint[0];
	(*cam).posY+=depctRepPoint[1];
	(*cam).posZ+=depctRepPoint[2];

	double posCam[]={(*cam).posX,(*cam).posY,(*cam).posZ};
	if (collisionBen(posCam)) randomSelectOnSphere(indexCam);
	return;
}
