#ifndef _PlaceCamera
#define _PlaceCamera

// classe utilisee que pour l'approche resolution de contrainte;
// l'approche basee idiomes utilisera d'autres methodes.

#include <cstdlib>
#include "Camera.h"
#include "View.h"
#include "Global.h"
#include "Constantes.h"
#include "Functions.h"

class PlaceCamera {

public :
	
	PlaceCamera () {
		cameras=new Camera[3];
		viewsCam=(int*)malloc(3*sizeof(int));
		viewsCam[0]=NB_VIEWS+1; // initialisation pour eviter les appels inutiles au premier passage dans init()
		viewsCam[1]=NB_VIEWS;
		viewsCam[2]=NB_VIEWS+2;
		srand(0);
	}
	
	PlaceCamera (const PlaceCamera& plCam) {
		cameras=new Camera[3];
		viewsCam=(int*)malloc(3*sizeof(int));
		cameras[1]=Camera(plCam.cameras[1]);
		cameras[0]=Camera(plCam.cameras[0]);
		cameras[2]=Camera(plCam.cameras[2]);
		viewsCam[1]=plCam.viewsCam[1];
		viewsCam[0]=plCam.viewsCam[0];
		viewsCam[2]=plCam.viewsCam[2];
		srand(0);
	}
	
	~PlaceCamera () {
		delete [] cameras;
		free(viewsCam);
	}
	
	// initialise la position de la camera
	void initCamPos(int indexCam);
	
	/*************************************************************************************
	* micro-fonctions : separation utile lors de la compilation finale des idiomes.
	* on aura en effet besoin seulement de la seconde partie de la fonction.
	*************************************************************************************/
	void testBestAngles(double* positionCam,double& visibilite,int indexCam);
	void getAleaView(int indexCam);
	// FIN DE CES MINI-FONCTIONS
	
	// fonctions auxiliaires d'initialisation [1] : cas de la main ou du bras entier
	void initPos_CG_Arm1();
	void initPos_CG_Arm0();
	void initPos_CG_Arm2();
	
	// fonction auxiliaire d'initialisation [2] : pour point entre bras et obstacle
	void initPos_Obstacle(int indexCam);
	
	// fonction auxiliaire pour calculer la nouvelle visibilite apres deplacement elementaire :
	double getVisibilite(int indexCam);
	
	// ajuste la position de la camera :
	void adjustCamPos(int indexCam);

	// selection aleatoire d'une position de la camera sur le cercle de vision du bras :
	void randomSelectOnCircle(int indexCam,double* coeffsX,double* coeffsY);
	
	// selection aleatoire d'une position de la camera sur la sphere de vision du bras :
	void randomSelectOnSphere(int indexCam);
	
	// deplace la camera selon les mouvements du bras-robot :
	void moveCamera(double* depctRepPoint,int indexCam);

	// cameras a gerer :
	Camera* cameras; // cam1: gauche; cam2: centre; cam3: droite
	
	// les types de vues des cameras a un instant donne
	int* viewsCam;
};

#endif
