#ifndef _Zone
#define _Zone

#include <cstdlib>
#include <cmath>
#include "Constantes.h"

// description d'une zone "parallelepipedique" autour de la station,
// en coordonnees cylindriques.

class Zone {
	
public :
	
	Zone () {}

	Zone (char* name,double z1,double z2,double phi1,double phi2,double ray1,double ray2) {
		this->name=name;
		this->z1=z1;
		this->z2=z1;
		this->phi1=phi1;
		this->phi2=phi2;
		this->ray1=ray1;
		this->ray2=ray2;
	}

	Zone (const Zone& zn) {
		name=zn.name;
		z1=zn.z1;
		z2=zn.z2;
		phi1=zn.phi1;
		phi2=zn.phi2;
		ray1=zn.ray1;
		ray2=zn.ray2;
	}

	~Zone () {}
	
	// fonction disant si un point 3D est dans la zone :
	bool isInside(double* point);

	char* name; // nom de la zone
	double z1,z2; // point le plus bas et le plus haut, respectivement, en ordonnee
	double phi1,phi2; // angles extremaux (phi1<phi2)
	double ray1,ray2; // rayons extremaux (ray1<ray2)

};

#endif
