#ifndef MPK_ZONE_H
#define MPK_ZONE_H

#include "mpk_inventor.h"

/**@memo Extended Inventor node type (derived from SoSeparator) to
   define zone nodes in the scene file.

   @doc mpkObstacles are found in the scene graph using an Inventor
   search action that looks for nodes of type mpkzone (see
   {@link mpkZoneCollection mpkZoneCollection}).  For each zone,
   an individual name can be given.  The following example shows how
   obstacles are defined in a scene file:\\ \\

   {\tt DEF testObst mpkObstacle {\\
     DEF __triangulate__ File { name "obj1.iv" }\\
     mpkTransform { translation 1 0 0 }\\
     DEF __triangulate__ File { name "obj2.iv" }\\
   }}\\ \\


   @see mpkObstacleCollection
 */
class mpkZone : public SoSeparator {
  
  SO_NODE_HEADER(mpkZone);
  
public:

  static void		initClass();
  
  ///
  mpkZone();
  
private:
  virtual ~mpkZone() {};
  
};



#endif
