#ifndef MPK_GUI_H
#define MPK_GUI_H

#include <vector>
#include <Inventor/Win/viewers/SoWinViewer.h>
#include <Inventor/Win/viewers/SoWinFullViewer.h>//ajout
#include <Inventor/SbLinear.h>
#include <Inventor/SoDB.h>
#include <Inventor/SoInput.h>
#include <Inventor/nodes/SoBlinker.h>
#include <Inventor/nodes/SoDirectionalLight.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoOrthographicCamera.h>
#include <Inventor/nodes/SoPerspectiveCamera.h>
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoTransform.h>
#include <Inventor/Win/SoWinRenderArea.h>
#include "mpk_inventor.h"
#include "mpkRobotCollection.H"
#include "mpkObstacleCollection.H"
#include "mpkZoneCollection.H"
#include "visible.h"
#include <Inventor/nodes/SoPointLight.h>
#include <Inventor/SbLinear.h>
#include <Inventor/nodes/SoFaceSet.h>
#include <Inventor/nodes/SoCoordinate3.h> 
//#include <Inventor/SbVec3d.h>
/**@memo Functions for reading scene files and for realizing a simple
   but powerful GUI.
 */
class mpkGUI{

public:

  static void init(char *argv[],
		   void (*myKeyPressCB)(void *, SoEventCallback *)=0,
		   void (*myMouseButtonCB)(void *, SoEventCallback *)=0);

  ///
  static void read_scene(const char* scene_fname);
  static void read_sceneSpatial(const char *scene_fname);

  /*************************************************************
  * @prog Benji : fonctions dupliquees pr scene avec que bras */
  static void initBen(char *argv[],
		   void (*myKeyPressCB)(void *, SoEventCallback *)=0,
		   void (*myMouseButtonCB)(void *, SoEventCallback *)=0);

  ///
  static void read_sceneBen(const char* scene_fname);
  static void read_sceneSpatialBen(const char *scene_fname);
  static void startBen(HWND myWindow1, HWND myWindow2, HWND myWindow3, HWND anim);
  /************************************************************/

  //// select an obstacle to view 
  static void select_obstacle(const char* name )
  {strcpy(selected,name);};

  ///
  static mpkRobotCollection* get_robots()
  {return new mpkRobotCollection(scene);};
  
  ///
  static mpkObstacleCollection* get_obstacles()
  {return new mpkObstacleCollection(scene);};

  ///
    static mpkZoneCollection* get_zones()
  {return new mpkZoneCollection(scene);};

  ///
  static mpkRobotCollection* get_spatialrobots()
  {return new mpkRobotCollection(sceneSpatial);};
  
  ///
  static mpkObstacleCollection* get_spatialobstacles()
  {return new mpkObstacleCollection(sceneSpatial);};

  ///
    static mpkZoneCollection* get_spatialzones()
  {return new mpkZoneCollection(sceneSpatial);};

  /// return the selected obstacle
  static mpkObstacleCollection* get_sel_obstacle()
  {return new mpkObstacleCollection(selected,scene);};

  static mpkObstacleCollection* get_sel_obstacleSpatial()
  {return new mpkObstacleCollection(selected,sceneSpatial);};

  ///
  static void start(HWND myWindow1, HWND myWindow2, HWND myWindow3, HWND anim);
 
  ///
  static void save_snapshot(const char* image_fname);

  //get the four point of a plane
  static void getCoord(SbViewVolume, const double, SbVec3f &, SbVec3f &, SbVec3f &, SbVec3f &);

  static void dessineZone(int,SoSeparator*,SoMaterial*,SoCoordinate3*,float[8][3],SoFaceSet*);

  static void configSpatialAwareness(HWND spaAwar);

   ///@memo Windows version only
  static SoWinExaminerViewer* myViewer1;
  static SoWinExaminerViewer* myViewer2;
  static SoWinExaminerViewer* myViewer3;
  static SoWinExaminerViewer* myViewerSpatial;
  ///@memo Windows version only
 
  ///
  static SoPerspectiveCamera* rootCamera1;
  static SoPerspectiveCamera* rootCamera2;
  static SoPerspectiveCamera* rootCamera3;
  static SoPerspectiveCamera* rootCameraSpatial;
  
  static SoSelection* gauche; //ajout
  static SoSelection* milieu; //ajout
  static SoSelection* droite; //ajout
   static SoSelection* animation; //ajout
  ///
  static SoSeparator* root1;
  static SoSeparator* root2;
  static SoSeparator* root3;
  static SoSeparator* rootSpatial;
  ///
  static SoSeparator* scene;
  static SoSeparator* sceneSpatial;
  
  static char* selected; /// the name of the selected obstacle

  static float *buffer1;
  static float *buffer2;
  static float *buffer3;

  //Pour la lumire
 
  static SoSwitch* dessineZones;

  static SoSeparator* ajoutZone1p1, *ajoutZone1p2, *ajoutZone1p3;
  static SoSeparator* ajoutZone2p1, *ajoutZone2p2, *ajoutZone2p3;
  static SoSeparator* ajoutZone3p1, *ajoutZone3p2, *ajoutZone3p3;
  static SoSeparator* ajoutZone4p1, *ajoutZone4p2, *ajoutZone4p3;
  static SoSeparator* ajoutZone5p1, *ajoutZone5p2, *ajoutZone5p3;
  static SoSeparator* ajoutZone6p1, *ajoutZone6p2, *ajoutZone6p3;
  
  static SoSwitch* zoneMonitor1;
  
  static SoMaterial* materielZone;
    
  static SoCoordinate3* plan1p1, *plan1p2, *plan1p3;
  static SoCoordinate3* plan2p1, *plan2p2, *plan2p3;
  static SoCoordinate3* plan3p1, *plan3p2, *plan3p3;
  static SoCoordinate3* plan4p1, *plan4p2, *plan4p3;
  static SoCoordinate3* plan5p1, *plan5p2, *plan5p3;
  static SoCoordinate3* plan6p1, *plan6p2, *plan6p3;

  static SoFaceSet* face1p1, *face1p2, *face1p3;
  static SoFaceSet* face2p1, *face2p2, *face2p3;
  static SoFaceSet* face3p1, *face3p2, *face3p3;
  static SoFaceSet* face4p1, *face4p2, *face4p3;
  static SoFaceSet* face5p1, *face5p2, *face5p3;
  static SoFaceSet* face6p1, *face6p2, *face6p3;

   /***************************************
  * @progBenji : variables dupliquees.. */

    ///@memo Windows version only
  static SoWinExaminerViewer* myViewer1Ben;
  static SoWinExaminerViewer* myViewer2Ben;
  static SoWinExaminerViewer* myViewer3Ben;
  static SoWinExaminerViewer* myViewerSpatialBen;
  ///@memo Windows version only
 
  ///
  static SoPerspectiveCamera* rootCamera1Ben;
  static SoPerspectiveCamera* rootCamera2Ben;
  static SoPerspectiveCamera* rootCamera3Ben;
  static SoPerspectiveCamera* rootCameraSpatialBen;
  
  static SoSelection* gaucheBen; //ajout
  static SoSelection* milieuBen; //ajout
  static SoSelection* droiteBen; //ajout
   static SoSelection* animationBen; //ajout
  ///
  static SoSeparator* root1Ben;
  static SoSeparator* root2Ben;
  static SoSeparator* root3Ben;
  static SoSeparator* rootSpatialBen;
  ///
  static SoSeparator* sceneBen;
  static SoSeparator* sceneSpatialBen;
  
  static char* selectedBen; /// the name of the selected obstacle

  static float *buffer1Ben;
  static float *buffer2Ben;
  static float *buffer3Ben;
  /***************************************/

private:

	// @progBenji : legere modif
	static SoEventCallback* myEventCB;

  ///
  static SoSeparator* scene_sep;
  static SoSeparator* spatialscene_sep;
  ///

	/***************************************
	* @progBenji : variables dupliquees.. */
	static SoSeparator* scene_sepBen;
	static SoSeparator* spatialscene_sepBen;
	/**************************************/

  static void init_extender_classes();

};

#endif


