#include "mpk_rand.h"
#include "mpkGUI.H"
#include "mpkRobot.H"
#include "mpkObstacle.H"
#include "mpkIncludeFile.H"
#include "mpkZone.H"

#include "camera.h"

SoWinExaminerViewer* mpkGUI::myViewer1;
SoWinExaminerViewer* mpkGUI::myViewer2;
SoWinExaminerViewer* mpkGUI::myViewer3;
SoWinExaminerViewer* mpkGUI::myViewerSpatial;

SoSelection* mpkGUI::gauche;
SoSelection* mpkGUI::milieu;
SoSelection* mpkGUI::droite;
SoSelection* mpkGUI::animation;

SoPerspectiveCamera* mpkGUI::rootCamera1;
SoPerspectiveCamera* mpkGUI::rootCamera2;
SoPerspectiveCamera* mpkGUI::rootCamera3;
SoPerspectiveCamera* mpkGUI::rootCameraSpatial;

SoSeparator* mpkGUI::root1;
SoSeparator* mpkGUI::root2;
SoSeparator* mpkGUI::root3;
SoSeparator* mpkGUI::rootSpatial;

SoSeparator* mpkGUI::scene;

SoSeparator* mpkGUI::sceneSpatial;
char* mpkGUI::selected;
SoSeparator* mpkGUI::scene_sep;
SoSeparator* mpkGUI::spatialscene_sep;

float* mpkGUI::buffer1;
float* mpkGUI::buffer2;
float* mpkGUI::buffer3;

SoSwitch* mpkGUI::dessineZones;

SoSeparator* mpkGUI::ajoutZone1p1;
SoSeparator* mpkGUI::ajoutZone2p1;
SoSeparator* mpkGUI::ajoutZone3p1;
SoSeparator* mpkGUI::ajoutZone4p1;
SoSeparator* mpkGUI::ajoutZone5p1;
SoSeparator* mpkGUI::ajoutZone6p1;

SoSeparator* mpkGUI::ajoutZone1p2;
SoSeparator* mpkGUI::ajoutZone2p2;
SoSeparator* mpkGUI::ajoutZone3p2;
SoSeparator* mpkGUI::ajoutZone4p2;
SoSeparator* mpkGUI::ajoutZone5p2;
SoSeparator* mpkGUI::ajoutZone6p2;

SoSeparator* mpkGUI::ajoutZone1p3;
SoSeparator* mpkGUI::ajoutZone2p3;
SoSeparator* mpkGUI::ajoutZone3p3;
SoSeparator* mpkGUI::ajoutZone4p3;
SoSeparator* mpkGUI::ajoutZone5p3;
SoSeparator* mpkGUI::ajoutZone6p3;

SoMaterial* mpkGUI::materielZone;

SoCoordinate3* mpkGUI::plan1p1;
SoCoordinate3* mpkGUI::plan2p1;
SoCoordinate3* mpkGUI::plan3p1;
SoCoordinate3* mpkGUI::plan4p1;
SoCoordinate3* mpkGUI::plan5p1;
SoCoordinate3* mpkGUI::plan6p1;

SoCoordinate3* mpkGUI::plan1p2;
SoCoordinate3* mpkGUI::plan2p2;
SoCoordinate3* mpkGUI::plan3p2;
SoCoordinate3* mpkGUI::plan4p2;
SoCoordinate3* mpkGUI::plan5p2;
SoCoordinate3* mpkGUI::plan6p2;

SoCoordinate3* mpkGUI::plan1p3;
SoCoordinate3* mpkGUI::plan2p3;
SoCoordinate3* mpkGUI::plan3p3;
SoCoordinate3* mpkGUI::plan4p3;
SoCoordinate3* mpkGUI::plan5p3;
SoCoordinate3* mpkGUI::plan6p3;

SoFaceSet* mpkGUI::face1p1;
SoFaceSet* mpkGUI::face2p1;
SoFaceSet* mpkGUI::face3p1;
SoFaceSet* mpkGUI::face4p1;
SoFaceSet* mpkGUI::face5p1;
SoFaceSet* mpkGUI::face6p1;

SoFaceSet* mpkGUI::face1p2;
SoFaceSet* mpkGUI::face2p2;
SoFaceSet* mpkGUI::face3p2;
SoFaceSet* mpkGUI::face4p2;
SoFaceSet* mpkGUI::face5p2;
SoFaceSet* mpkGUI::face6p2;

SoFaceSet* mpkGUI::face1p3;
SoFaceSet* mpkGUI::face2p3;
SoFaceSet* mpkGUI::face3p3;
SoFaceSet* mpkGUI::face4p3;
SoFaceSet* mpkGUI::face5p3;
SoFaceSet* mpkGUI::face6p3;

// @progBenji : legere modif
SoEventCallback* mpkGUI::myEventCB;

void mpkGUI::init(char *argv[],void (*myKeyPressCB)(void *, SoEventCallback *),void (*myMouseButtonCB)(void *, SoEventCallback *))
{
  init_extender_classes();

  root1 = new SoSeparator;
  root1->ref();

  root2 = new SoSeparator;
  root2->ref();

  root3 = new SoSeparator;
  root3->ref();

  rootSpatial = new SoSeparator;
  rootSpatial->ref();
  
  myEventCB = new SoEventCallback;
  root1->addChild(myEventCB);
  root2->addChild(myEventCB);
  root3->addChild(myEventCB);
  rootSpatial->addChild(myEventCB);
  if ( myKeyPressCB )
    myEventCB->addEventCallback(SoEvent::getClassTypeId(),myKeyPressCB, 0);
  if ( myMouseButtonCB )
    myEventCB->addEventCallback(SoEvent::getClassTypeId(),myMouseButtonCB, 0);

  rootCamera1 = new SoPerspectiveCamera;
  rootCamera2 = new SoPerspectiveCamera;
  rootCamera3 = new SoPerspectiveCamera;
  rootCameraSpatial = new SoPerspectiveCamera;

  selected = new char[5];

  root1->addChild(rootCamera1);
  root2->addChild(rootCamera2);
  root3->addChild(rootCamera3);
  rootSpatial->addChild(rootCameraSpatial);

  scene = new SoSeparator;
  sceneSpatial = new SoSeparator;
  
  root1->addChild(scene);
  root2->addChild(scene);
  root3->addChild(scene);
  rootSpatial->addChild(sceneSpatial);
  
  //Pour les trois fenetres
  gauche = new SoSelection;
  gauche->addChild(root1); 

  milieu = new SoSelection;
  milieu->addChild(root2);

  droite = new SoSelection;
  droite->addChild(root3);

  animation = new SoSelection;
  animation->addChild(rootSpatial); 

  scene_sep = 0;
  spatialscene_sep=0;
  myViewer1 = 0;
  myViewer2 = 0;
  myViewer3 = 0;
  myViewerSpatial = 0;

  dessineZones = new SoSwitch;
  dessineZones->whichChild = SO_SWITCH_NONE;
  root1->addChild(dessineZones);
  root2->addChild(dessineZones);
  root3->addChild(dessineZones);

  ajoutZone1p1 = new SoSeparator;
  ajoutZone2p1 = new SoSeparator;
  ajoutZone3p1 = new SoSeparator;
  ajoutZone4p1 = new SoSeparator;
  ajoutZone5p1 = new SoSeparator;
  ajoutZone6p1 = new SoSeparator;

  ajoutZone1p2 = new SoSeparator;
  ajoutZone2p2 = new SoSeparator;
  ajoutZone3p2 = new SoSeparator;
  ajoutZone4p2 = new SoSeparator;
  ajoutZone5p2 = new SoSeparator;
  ajoutZone6p2 = new SoSeparator;

  ajoutZone1p3 = new SoSeparator;
  ajoutZone2p3 = new SoSeparator;
  ajoutZone3p3 = new SoSeparator;
  ajoutZone4p3 = new SoSeparator;
  ajoutZone5p3 = new SoSeparator;
  ajoutZone6p3 = new SoSeparator;

  plan1p1 = new SoCoordinate3;
  plan2p1 = new SoCoordinate3;
  plan3p1 = new SoCoordinate3;
  plan4p1 = new SoCoordinate3;
  plan5p1 = new SoCoordinate3;
  plan6p1 = new SoCoordinate3;

  plan1p2 = new SoCoordinate3;
  plan2p2 = new SoCoordinate3;
  plan3p2 = new SoCoordinate3;
  plan4p2 = new SoCoordinate3;
  plan5p2 = new SoCoordinate3;
  plan6p2 = new SoCoordinate3;

  plan1p3 = new SoCoordinate3;
  plan2p3 = new SoCoordinate3;
  plan3p3 = new SoCoordinate3;
  plan4p3 = new SoCoordinate3;
  plan5p3 = new SoCoordinate3;
  plan6p3 = new SoCoordinate3;

  materielZone = new SoMaterial;

  face1p1 = new SoFaceSet;
  face2p1 = new SoFaceSet;
  face3p1 = new SoFaceSet;
  face4p1 = new SoFaceSet;
  face5p1 = new SoFaceSet;
  face6p1 = new SoFaceSet;

  face1p2 = new SoFaceSet;
  face2p2 = new SoFaceSet;
  face3p2 = new SoFaceSet;
  face4p2 = new SoFaceSet;
  face5p2 = new SoFaceSet;
  face6p2 = new SoFaceSet;

  face1p3 = new SoFaceSet;
  face2p3 = new SoFaceSet;
  face3p3 = new SoFaceSet;
  face4p3 = new SoFaceSet;
  face5p3 = new SoFaceSet;
  face6p3 = new SoFaceSet;

}

void mpkGUI::read_scene(const char *scene_fname)
{
  if ( scene_sep ) {scene->removeChild(scene_sep); }
  
  SoInput sceneInput;
  sceneInput.addDirectoryFirst("ivmodels");
  sceneInput.addEnvDirectoriesFirst("IVMODELS");
  sceneInput.addDirectoryLast("ivmodels.private");
  sceneInput.openFile(scene_fname);
  scene_sep = SoDB::readAll(&sceneInput);
  if ( !scene_sep ) {
    cerr << "mpkGUI::init(): Error reading file " << scene_fname << endl;
#ifdef WIN32
    getchar();
#endif
    exit(1);
  }
  scene->addChild(scene_sep);

  SoSearchAction searchincl;
  searchincl.setType(mpkIncludeFile::getClassTypeId());
  searchincl.setInterest(SoSearchAction::ALL);
  searchincl.setSearchingAll(TRUE);
  searchincl.apply(root1);
  searchincl.apply(root2);
  searchincl.apply(root3);
  SoPathList incllist = searchincl.getPaths();
  for ( int k=0; k < incllist.getLength(); k++ ) {
    mpkIncludeFile* inclf = (mpkIncludeFile*)incllist[k]->getNodeFromTail(0);
    inclf->read_and_init();
  }
}

void mpkGUI::read_sceneSpatial(const char *scene_fname)
{
  if ( spatialscene_sep ) { sceneSpatial->removeChild(spatialscene_sep); }
  
  SoInput sceneInput;
  sceneInput.addDirectoryFirst("ivmodels");
  sceneInput.addEnvDirectoriesFirst("IVMODELS");
  sceneInput.addDirectoryLast("ivmodels.private");
  sceneInput.openFile(scene_fname);
  spatialscene_sep = SoDB::readAll(&sceneInput);
  if ( !spatialscene_sep  ) {
    cerr << "mpkGUI::init(): Error reading file " << scene_fname << endl;
#ifdef WIN32
    getchar();
#endif
    exit(1);
  }
  sceneSpatial->addChild(spatialscene_sep);

  SoSearchAction searchincl;
  searchincl.setType(mpkIncludeFile::getClassTypeId());
  searchincl.setInterest(SoSearchAction::ALL);
  searchincl.setSearchingAll(TRUE);
  searchincl.apply(rootSpatial);
  SoPathList incllist = searchincl.getPaths();
  for ( int k=0; k < incllist.getLength(); k++ ) {
    mpkIncludeFile* inclf = (mpkIncludeFile*)incllist[k]->getNodeFromTail(0);
    inclf->read_and_init();
  }
}

void mpkGUI::configSpatialAwareness(HWND spaAwar){

	myViewerSpatial = new SoWinExaminerViewer(spaAwar);

	SoWinRenderArea *myRenderArea1 = new SoWinRenderArea();
    SbViewportRegion myRegion(myRenderArea1->getSize());
    rootCameraSpatial->viewAll(animation, myRegion);

	myViewerSpatial->setSceneGraph(animation);
    myViewerSpatial->setGLRenderAction(new SoBoxHighlightRenderAction());
    //myViewerSpatial->redrawOnSelectionChange(gauche);
    myViewerSpatial->setBackgroundColor(SbColor(0,0,0));
    myViewerSpatial->setSize(SbVec2s(450,480));
    myViewerSpatial->setDecoration(TRUE);
    myViewerSpatial->setViewing(TRUE);
    myViewerSpatial->setPopupMenuEnabled(TRUE);
    myViewerSpatial->setAutoClipping(true);

	camera::set_camParam(rootCameraSpatial, -327.914,-1471.5,731.034,0.25564,0.492862,-0.831707,2.57394, 1.0, 1.0, 10.0, 4400.13, 0.8);

	myViewerSpatial->show();
}

void mpkGUI::start(HWND myWindow1, HWND myWindow2, HWND myWindow3, HWND anim){
    
    myViewer1 = new SoWinExaminerViewer(myWindow1);
    myViewer2 = new SoWinExaminerViewer(myWindow2);
    myViewer3 = new SoWinExaminerViewer(myWindow3);
	//myViewerSpatial = new SoWinExaminerViewer(anim);

    SoWinRenderArea *myRenderArea1 = new SoWinRenderArea();
    SbViewportRegion myRegion1(myRenderArea1->getSize());
    rootCamera1->viewAll(root1, myRegion1);
    rootCamera2->viewAll(root2, myRegion1);
    rootCamera3->viewAll(root3, myRegion1);
	//rootCameraSpatial->viewAll(rootSpatial, myRegion1);

    //myViewer1
    myViewer1->setSceneGraph(gauche);
    myViewer1->setGLRenderAction(new SoBoxHighlightRenderAction());
    myViewer1->redrawOnSelectionChange(gauche);
    myViewer1->setBackgroundColor(SbColor(0,0,0));
    myViewer1->setSize(SbVec2s(1300,1000));
    myViewer1->setDecoration(TRUE);
    myViewer1->setViewing(TRUE);
    myViewer1->setPopupMenuEnabled(TRUE);
    myViewer1->setAutoClipping(true);

    //myViewer2
    myViewer2->setSceneGraph(milieu);
    myViewer2->setGLRenderAction(new SoBoxHighlightRenderAction());
    myViewer2->redrawOnSelectionChange(milieu);
    myViewer2->setBackgroundColor(SbColor(0,0,0));
    myViewer2->setSize(SbVec2s(1300,1000));
    myViewer2->setDecoration(TRUE);
    myViewer2->setViewing(TRUE);
    myViewer2->setPopupMenuEnabled(TRUE);
    myViewer2->setAutoClipping(true);

	//myViewer3
	myViewer3->setSceneGraph(droite);
    myViewer3->setGLRenderAction(new SoBoxHighlightRenderAction());
    myViewer3->redrawOnSelectionChange(droite);
    myViewer3->setBackgroundColor(SbColor(0,0,0));
    myViewer3->setSize(SbVec2s(1300,1000));
    myViewer3->setDecoration(TRUE);
    myViewer3->setViewing(TRUE);
    myViewer3->setPopupMenuEnabled(TRUE);
    myViewer3->setAutoClipping(true);

	/*myViewerSpatial->setSceneGraph(rootSpatial);
    //myViewerSpatial->setGLRenderAction(new SoBoxHighlightRenderAction());
    //myViewerSpatial->redrawOnSelectionChange(droite);
    myViewerSpatial->setBackgroundColor(SbColor(0.8,0.8,1));
    myViewerSpatial->setSize(SbVec2s(420,380));
    //myViewerSpatial->setDecoration(TRUE);
    //myViewerSpatial->setViewing(FALSE);
    //myViewerSpatial->setPopupMenuEnabled(TRUE);
    //myViewerSpatial->setAutoClipping(true);*/

    camera::set_camParam(rootCamera1, -327.914,-1471.5,731.034,0.25564,0.492862,-0.831707,2.57394, 1.0, 1.0, 10.0, 4400.13, 0.8);
    camera::set_camParam(rootCamera2, 6.20204,12.573,357.522,-0.405432,-0.0334774,-0.913512,2.85253,1.0, 1.0, 10.0, 0.1, 0.8);
	camera::set_camParam(rootCamera3, -177.013,-85.2833,-327.652,-0.976241,-0.215468,-0.0229823,3.22506,1.0, 1.0, 10.0, 0.1, 0.8);

    myViewer1->show();
    myViewer2->show();
    myViewer3->show();
  }

void mpkGUI::save_snapshot(const char* image_fname)
{
  cerr << "mpkGUI::save_snapshot(): not supported." << endl;
}

void mpkGUI::init_extender_classes()
{
  mpkRobot::initClass();
  mpkObstacle::initClass();
  mpkZone::initClass();
  mpkIncludeFile::initClass();
}

void mpkGUI::getCoord(SbViewVolume pyramide, const double distance, SbVec3f & lowerleft, SbVec3f & lowerright, SbVec3f & upperleft, SbVec3f & upperright){
	  
	SbVec3f near_ur = pyramide.ulf + (pyramide.lrf-pyramide.llf);

	double depth = pyramide.nearDist + distance;
    SbVec3f dir;
    dir = pyramide.llf;
    dir.normalize();
    lowerleft = dir * depth / dir.dot(pyramide.projDir);

    dir = pyramide.lrf;
    dir.normalize();
    lowerright = dir * depth / dir.dot(pyramide.projDir);
        
	dir = pyramide.ulf;
    dir.normalize();
    upperleft = dir * depth / dir.dot(pyramide.projDir);
        
	dir = near_ur;
    dir.normalize();
    upperright = dir * depth / dir.dot(pyramide.projDir);
	    
    //lowerleft = pyramide.llf + pyramide.projDir * distance;
    //lowerright = pyramide.lrf + pyramide.projDir * distance;
    //upperleft = pyramide.ulf + pyramide.projDir * distance;
    //upperright = near_ur + pyramide.projDir * distance;	
}

void mpkGUI::dessineZone(int des, SoSeparator* ajoutZone, SoMaterial* mat, SoCoordinate3* points, float coord[4][3],SoFaceSet* base){

	if(des == 0){
        dessineZones->whichChild = SO_SWITCH_ALL;
        //ajoutZone = new SoSeparator;

        //mat = new SoMaterial;
        mat->ambientColor.setValue(.33,.22,.27);
        mat->diffuseColor.setValue(.78,.57,.11);
        mat->specularColor.setValue(.99,.94,.81);
        mat->shininess = .28;
		mat->transparency = 0.5;

		//points = new SoCoordinate3;
		points->point.setValues(0,4,coord);
		ajoutZone->addChild(points);
        //base = new SoFaceSet;
		base->numVertices.set1Value(0,4);
		ajoutZone->addChild(mat);
		ajoutZone->addChild(base);
        
		dessineZones->addChild(ajoutZone);
	}
	else{
		dessineZones->whichChild = SO_SWITCH_NONE;
	}
}

/*********************************************************************************
* @prog Benji : scene offscreen pr tests de visibilite --> duplication totale.. */

SoWinExaminerViewer* mpkGUI::myViewer1Ben;
SoWinExaminerViewer* mpkGUI::myViewer2Ben;
SoWinExaminerViewer* mpkGUI::myViewer3Ben;
SoWinExaminerViewer* mpkGUI::myViewerSpatialBen;

SoSelection* mpkGUI::gaucheBen;
SoSelection* mpkGUI::milieuBen;
SoSelection* mpkGUI::droiteBen;
SoSelection* mpkGUI::animationBen;

SoPerspectiveCamera* mpkGUI::rootCamera1Ben;
SoPerspectiveCamera* mpkGUI::rootCamera2Ben;
SoPerspectiveCamera* mpkGUI::rootCamera3Ben;
SoPerspectiveCamera* mpkGUI::rootCameraSpatialBen;

SoSeparator* mpkGUI::root1Ben;
SoSeparator* mpkGUI::root2Ben;
SoSeparator* mpkGUI::root3Ben;
SoSeparator* mpkGUI::rootSpatialBen;

SoSeparator* mpkGUI::sceneBen;

SoSeparator* mpkGUI::sceneSpatialBen;
char* mpkGUI::selectedBen;
SoSeparator* mpkGUI::scene_sepBen;
SoSeparator* mpkGUI::spatialscene_sepBen;

float* mpkGUI::buffer1Ben;
float* mpkGUI::buffer2Ben;
float* mpkGUI::buffer3Ben;

// @prog Benji : initialisation de la scene ne contenant que le bras
void mpkGUI::initBen(char *argv[],void (*myKeyPressCB)(void *, SoEventCallback *),void (*myMouseButtonCB)(void *, SoEventCallback *))
{
  root1Ben = new SoSeparator;
  root1->ref();

  root2Ben = new SoSeparator;
  root2->ref();

  root3Ben = new SoSeparator;
  root3->ref();

  rootSpatialBen = new SoSeparator;
  rootSpatial->ref();
  
  root1Ben->addChild(myEventCB);
  root2Ben->addChild(myEventCB);
  root3Ben->addChild(myEventCB);
  rootSpatialBen->addChild(myEventCB);
  if ( myKeyPressCB )
    myEventCB->addEventCallback(SoEvent::getClassTypeId(),myKeyPressCB, 0);
  if ( myMouseButtonCB )
    myEventCB->addEventCallback(SoEvent::getClassTypeId(),myMouseButtonCB, 0);

  rootCamera1Ben = new SoPerspectiveCamera;
  rootCamera2Ben = new SoPerspectiveCamera;
  rootCamera3Ben = new SoPerspectiveCamera;
  rootCameraSpatialBen = new SoPerspectiveCamera;

  selectedBen = new char[5];

  root1Ben->addChild(rootCamera1Ben);
  root2Ben->addChild(rootCamera2Ben);
  root3Ben->addChild(rootCamera3Ben);
  rootSpatial->addChild(rootCameraSpatialBen);

  sceneBen = new SoSeparator;
  sceneSpatialBen = new SoSeparator;
  
  root1Ben->addChild(sceneBen);
  root2Ben->addChild(sceneBen);
  root3Ben->addChild(sceneBen);
  rootSpatialBen->addChild(sceneSpatialBen);
  
  //Pour les trois fenetres
  gaucheBen = new SoSelection;
  gaucheBen->addChild(root1Ben); 

  milieuBen = new SoSelection;
  milieuBen->addChild(root2Ben);

  droiteBen = new SoSelection;
  droiteBen->addChild(root3Ben);

  animationBen = new SoSelection;
  animationBen->addChild(rootSpatialBen); 

  scene_sepBen = 0;
  spatialscene_sepBen=0;
  myViewer1Ben = 0;
  myViewer2Ben = 0;
  myViewer3Ben = 0;
  myViewerSpatialBen = 0;
}

// @prog Benji : lecture de la scene  ne contenant que le bras
void mpkGUI::read_sceneBen(const char *scene_fname)
{
  if ( scene_sepBen ) {sceneBen->removeChild(scene_sepBen); }
  
  SoInput sceneInput;
  sceneInput.addDirectoryFirst("ivmodels");
  sceneInput.addEnvDirectoriesFirst("IVMODELS");
  sceneInput.addDirectoryLast("ivmodels.private");
  sceneInput.openFile(scene_fname);
  scene_sepBen = SoDB::readAll(&sceneInput);
  if ( !scene_sepBen ) {
    cerr << "mpkGUI::initBen(): Error reading file " << scene_fname << endl;
#ifdef WIN32
    getchar();
#endif
    exit(1);
  }
  sceneBen->addChild(scene_sepBen);

  SoSearchAction searchincl;
  searchincl.setType(mpkIncludeFile::getClassTypeId());
  searchincl.setInterest(SoSearchAction::ALL);
  searchincl.setSearchingAll(TRUE);
  searchincl.apply(root1Ben);
  searchincl.apply(root2Ben);
  searchincl.apply(root3Ben);
  SoPathList incllist = searchincl.getPaths();
  for ( int k=0; k < incllist.getLength(); k++ ) {
    mpkIncludeFile* inclf = (mpkIncludeFile*)incllist[k]->getNodeFromTail(0);
    inclf->read_and_init();
  }
}

// @prog Benji : lecture de la scene "spatiale"  ne contenant que le bras
void mpkGUI::read_sceneSpatialBen(const char *scene_fname)
{
  if ( spatialscene_sepBen ) { sceneSpatialBen->removeChild(spatialscene_sepBen); }
  
  SoInput sceneInput;
  sceneInput.addDirectoryFirst("ivmodels");
  sceneInput.addEnvDirectoriesFirst("IVMODELS");
  sceneInput.addDirectoryLast("ivmodels.private");
  sceneInput.openFile(scene_fname);
  spatialscene_sepBen = SoDB::readAll(&sceneInput);
  if ( !spatialscene_sepBen  ) {
    cerr << "mpkGUI::initBen(): Error reading file " << scene_fname << endl;
#ifdef WIN32
    getchar();
#endif
    exit(1);
  }
  sceneSpatialBen->addChild(spatialscene_sepBen);

  SoSearchAction searchincl;
  searchincl.setType(mpkIncludeFile::getClassTypeId());
  searchincl.setInterest(SoSearchAction::ALL);
  searchincl.setSearchingAll(TRUE);
  searchincl.apply(rootSpatialBen);
  SoPathList incllist = searchincl.getPaths();
  for ( int k=0; k < incllist.getLength(); k++ ) {
    mpkIncludeFile* inclf = (mpkIncludeFile*)incllist[k]->getNodeFromTail(0);
    inclf->read_and_init();
  }
}

void mpkGUI::startBen(HWND myWindow1, HWND myWindow2, HWND myWindow3, HWND anim){
    
    myViewer1Ben = new SoWinExaminerViewer(myWindow1);
    myViewer2Ben = new SoWinExaminerViewer(myWindow2);
    myViewer3Ben = new SoWinExaminerViewer(myWindow3);
	//myViewerSpatialBen = new SoWinExaminerViewer(anim);

    SoWinRenderArea *myRenderArea1 = new SoWinRenderArea();
    SbViewportRegion myRegion1(myRenderArea1->getSize());
    rootCamera1Ben->viewAll(root1Ben, myRegion1);
    rootCamera2Ben->viewAll(root2Ben, myRegion1);
    rootCamera3Ben->viewAll(root3Ben, myRegion1);
	//rootCameraSpatial->viewAll(rootSpatial, myRegion1);

    //myViewer1Ben
    myViewer1Ben->setSceneGraph(gauche);
    myViewer1Ben->setGLRenderAction(new SoBoxHighlightRenderAction());
    myViewer1Ben->redrawOnSelectionChange(gauche);
    myViewer1Ben->setBackgroundColor(SbColor(0,0,0));
    myViewer1Ben->setSize(SbVec2s(1300,1000));
    myViewer1Ben->setDecoration(TRUE);
    myViewer1Ben->setViewing(TRUE);
    myViewer1Ben->setPopupMenuEnabled(TRUE);
    myViewer1Ben->setAutoClipping(true);

    //myViewer2
    myViewer2Ben->setSceneGraph(milieu);
    myViewer2Ben->setGLRenderAction(new SoBoxHighlightRenderAction());
    myViewer2Ben->redrawOnSelectionChange(milieu);
    myViewer2Ben->setBackgroundColor(SbColor(0,0,0));
    myViewer2Ben->setSize(SbVec2s(1300,1000));
    myViewer2Ben->setDecoration(TRUE);
    myViewer2Ben->setViewing(TRUE);
    myViewer2Ben->setPopupMenuEnabled(TRUE);
    myViewer2Ben->setAutoClipping(true);

	//myViewer3
	myViewer3Ben->setSceneGraph(droite);
    myViewer3Ben->setGLRenderAction(new SoBoxHighlightRenderAction());
    myViewer3Ben->redrawOnSelectionChange(droite);
    myViewer3Ben->setBackgroundColor(SbColor(0,0,0));
    myViewer3Ben->setSize(SbVec2s(1300,1000));
    myViewer3Ben->setDecoration(TRUE);
    myViewer3Ben->setViewing(TRUE);
    myViewer3Ben->setPopupMenuEnabled(TRUE);
    myViewer3Ben->setAutoClipping(true);

	/*myViewerSpatialBen->setSceneGraph(rootSpatial);
    //myViewerSpatialBen->setGLRenderAction(new SoBoxHighlightRenderAction());
    //myViewerSpatialBen->redrawOnSelectionChange(droite);
    myViewerSpatialBen->setBackgroundColor(SbColor(0.8,0.8,1));
    myViewerSpatialBen->setSize(SbVec2s(420,380));
    //myViewerSpatialBen->setDecoration(TRUE);
    //myViewerSpatialBen->setViewing(FALSE);
    //myViewerSpatialBen->setPopupMenuEnabled(TRUE);
    //myViewerSpatialBen->setAutoClipping(true);*/

/* code semblant correspondre a l'affichage ; commente !
    camera::set_camParam(rootCamera1, -327.914,-1471.5,731.034,0.25564,0.492862,-0.831707,2.57394, 1.0, 1.0, 10.0, 4400.13, 0.8);
    camera::set_camParam(rootCamera2, 6.20204,12.573,357.522,-0.405432,-0.0334774,-0.913512,2.85253,1.0, 1.0, 10.0, 0.1, 0.8);
	camera::set_camParam(rootCamera3, -177.013,-85.2833,-327.652,-0.976241,-0.215468,-0.0229823,3.22506,1.0, 1.0, 10.0, 0.1, 0.8);

    myViewer1->show();
    myViewer2->show();
    myViewer3->show();
*/
  }
/**************************************************************************/
