#ifndef SBL_BIN_H
#define SBL_BIN_H

#include <iostream>
#include <vector>

#include "sblMilestone.H"

/**@memo Class sblBin is used to keep record on the distribution of the
   nodes on C-space.  Each bin containts an identifier, given by i, a
   counter where the number of nodes in the bin is kept (count), and a
   space to store a certain number of nodes per bin. There are also
   some auxiliary functions.
*/

class sblBin {
  
 public:
  
  ///
  sblBin() {
	  best_dd.clear();
      best_mil.clear();}

  ~sblBin() {
	  //best_dd.clear();
      //best_mil.clear();
  }

  ///
  sblBin(const sblMilestone& m)
    {
      // Add the node index at the first position
      data.push_back(m.getIndex());
	  if (best_dd.size()!=0 && m.get_dd()>best_dd[best_dd.size()-1])
	  {best_mil.push_back(m.getIndex());
	  best_dd.push_back(m.get_dd());}
	  else if (best_dd.size()==0)
	  {best_mil.push_back(m.getIndex());
	  best_dd.push_back(m.get_dd());}
	  
   }
  
  /**@doc For adding a milestone in the bin */
  void add_node(const sblMilestone& node)
    { 
      data.push_back(node.getIndex());

	  if (best_dd.size()!=0 && node.get_dd()>best_dd[best_dd.size()-1])
	    {best_mil.push_back(node.getIndex());
	  best_dd.push_back(node.get_dd());}
	  
	  else if (best_dd.size()==0)
	    {best_mil.push_back(node.getIndex());
	     best_dd.push_back(node.get_dd());}

    }
  
  /**@doc For deleting a node from the bin */
  void del_node(const sblMilestone& node)
    { 
		if (best_dd.size()!=0 && node.get_dd()==best_dd[best_dd.size()-1] && node.getIndex()==best_mil[best_mil.size()-1])
		{best_mil.pop_back();
		best_dd.pop_back();}

	else if (best_dd.size()==0)
	{best_mil.clear();
	 best_dd.clear();}
      
	vector<int>::iterator I;
      for(I=data.begin(); I!=data.end(); ++I)
	if((*I)== node.getIndex())
	  break;  
      data.erase(I);

    }
  
  /**@doc Returns the size of the bin */
  int getSize()
    {
      return data.size();
    }

  /**@doc Retrieves an entry */
  int getData(int i)
    { 
      return data[i];
    }

  /**@doc Prints the bin list */
  double get_dd()
	      {
      if(best_dd.size()!=0)
	    {return best_dd[best_dd.size()-1];}
	  else 
	  {return 0;}
    }
  void print()
    {
      vector<int>::iterator I;
      for(I=data.begin(); I!=data.end(); ++I)
	cerr << (*I) << ", ";
      cerr << endl;
    }
 
  ///@memo To store the indexes of the nodes on the bin
  vector<int> data;
   ///@memo To store the index of the best node in the bin
  vector<int> best_mil;
   ///@memo To store the best degree of desirability in the bin
  vector<double> best_dd;
};
#endif











